'use strict';

Object.defineProperty(exports, "__esModule", {
	value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _dateformat = require('dateformat');

var _dateformat2 = _interopRequireDefault(_dateformat);

var _moment = require('moment');

var _moment2 = _interopRequireDefault(_moment);

var _cheerio = require('cheerio');

var _cheerio2 = _interopRequireDefault(_cheerio);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

var Utils = function () {
	function Utils() {
		_classCallCheck(this, Utils);
	}

	_createClass(Utils, null, [{
		key: 'prepareGSArrayForTable',
		value: function prepareGSArrayForTable(gsArray) {

			if (gsArray.length <= 0) return null;

			var tableData = [];

			var columnRow = gsArray[0];

			for (var i = 1; i < gsArray.length; i++) {

				var row = gsArray[i];
				var rowObject = { id: i };

				for (var j = 0; j < row.length; j++) {
					rowObject[columnRow[j]] = row[j];
				}
				if (tableData.indexOf(rowObject) < 0) tableData.push(rowObject);
			}
			return tableData;
		}
	}, {
		key: 'getFirstWordOfString',
		value: function getFirstWordOfString(str) {
			if (!str || str.length <= 0 || str.indexOf(" ") < 0) return str;

			return str.substr(0, str.indexOf(" "));
		}
	}, {
		key: 'getBlogArchiveFromBlogData',
		value: function getBlogArchiveFromBlogData(data) {

			if (!data || data === null) return null;

			var items = data.items || data;
			if (!items || items === null || items.length <= 0) return null;

			var archive = {};

			for (var i = 0, l = items.length; i < l; i++) {
				var publishedDate = new Date(items[i].published);
				var year = publishedDate.getFullYear();
				var month = (0, _dateformat2.default)(publishedDate, "mmmm");

				if (!archive[year]) archive[year] = {};

				if (!archive[year][month]) archive[year][month] = { posts: [] };

				archive[year][month].posts.push(items[i]);
			}

			return archive;
		}
	}, {
		key: 'toTitleCase',
		value: function toTitleCase(str) {
			return str.replace(/\w\S*/g, function (txt) {
				return txt.charAt(0).toUpperCase() + txt.substr(1).toLowerCase();
			});
		}
	}, {
		key: 'getValidDate',
		value: function getValidDate(dateString, utc) {
			if (utc) return new Date(_moment2.default.utc(dateString).valueOf());else return new Date((0, _moment2.default)(dateString).valueOf());
		}
	}, {
		key: 'stripHtml',
		value: function stripHtml(htmlString) {
			return htmlString.replace(/<[^>]+>/g, '');
		}
	}, {
		key: 'getFirstImageSourceFromHtml',
		value: function getFirstImageSourceFromHtml(htmlString) {
			var $ = _cheerio2.default.load(htmlString);
			var matches = $('img').attr('src');
			return matches;
		}
	}, {
		key: 'groupByField',
		value: function groupByField(groupField, array) {
			var reducer = function reducer(result, currItem) {
				// Create new group
				if (!result[currItem[groupField]]) result[currItem[groupField]] = {
					title: currItem[groupField],
					items: []
				};
				// Append to group
				result[currItem[groupField]].items.push(currItem);

				delete currItem[groupField];

				return result;
			};
			var groupedArray = Object.values(array.reduce(reducer, {}));
			return groupedArray;
		}
	}]);

	return Utils;
}();

exports.default = Utils;