'use strict';

Object.defineProperty(exports, "__esModule", {
    value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _GradientScreen = require('./GradientScreen');

var _GradientScreen2 = _interopRequireDefault(_GradientScreen);

var _ShadowScreen = require('./ShadowScreen');

var _ShadowScreen2 = _interopRequireDefault(_ShadowScreen);

var _MeasuredContainer = require('../elements/MeasuredContainer');

var _MeasuredContainer2 = _interopRequireDefault(_MeasuredContainer);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var BackgroundPosterShadow = function (_React$PureComponent) {
    _inherits(BackgroundPosterShadow, _React$PureComponent);

    function BackgroundPosterShadow() {
        _classCallCheck(this, BackgroundPosterShadow);

        return _possibleConstructorReturn(this, (BackgroundPosterShadow.__proto__ || Object.getPrototypeOf(BackgroundPosterShadow)).apply(this, arguments));
    }

    _createClass(BackgroundPosterShadow, [{
        key: 'render',
        value: function render() {

            var smallScreen = this.props.containerWidth < 768;
            var largeScreen = this.props.containerWidth >= 1200;
            var mediumScreen = !smallScreen && !largeScreen;

            var visibleAreaLength = largeScreen ? -100 : mediumScreen ? 100 : 200;

            var color = 'rgba(0, 0, 0, 0.95)';

            //return <div />;

            return _react2.default.createElement('div', { className: 'kokolib_shadowScreen_fog', style: {
                    content: "",
                    height: '100%',
                    left: 0,
                    margin: '0 auto',
                    pointerEvents: 'none',
                    position: 'absolute',
                    right: 0,
                    top: 0,
                    background: 'rgba(255,255,255,0.3)'
                } });
        }
    }]);

    return BackgroundPosterShadow;
}(_react2.default.PureComponent);

var BackgroundPoster = function (_React$PureComponent2) {
    _inherits(BackgroundPoster, _React$PureComponent2);

    function BackgroundPoster() {
        _classCallCheck(this, BackgroundPoster);

        return _possibleConstructorReturn(this, (BackgroundPoster.__proto__ || Object.getPrototypeOf(BackgroundPoster)).apply(this, arguments));
    }

    _createClass(BackgroundPoster, [{
        key: 'render',
        value: function render() {

            return _react2.default.createElement(
                'div',
                { style: {
                        backgroundImage: 'url(\'' + this.props.imagePath + '\')',
                        backgroundSize: 'cover',
                        backgroundPosition: 'center',
                        width: '100%',
                        height: '100%',
                        position: 'fixed'
                    } },
                this.props.addShadow && _react2.default.createElement(
                    _MeasuredContainer2.default,
                    null,
                    _react2.default.createElement(BackgroundPosterShadow, null)
                )
            );
        }
    }]);

    return BackgroundPoster;
}(_react2.default.PureComponent);

BackgroundPoster.propTypes = {
    imagePath: _propTypes2.default.string,
    addShadow: _propTypes2.default.bool
};
BackgroundPoster.defaultProps = {
    imagePath: "",
    addShadow: false
};
exports.default = BackgroundPoster;