'use strict';

Object.defineProperty(exports, "__esModule", {
	value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _Button = require('@material-ui/core/Button');

var _Button2 = _interopRequireDefault(_Button);

var _Dialog = require('@material-ui/core/Dialog');

var _Dialog2 = _interopRequireDefault(_Dialog);

var _DialogActions = require('@material-ui/core/DialogActions');

var _DialogActions2 = _interopRequireDefault(_DialogActions);

var _DialogContent = require('@material-ui/core/DialogContent');

var _DialogContent2 = _interopRequireDefault(_DialogContent);

var _DialogContentText = require('@material-ui/core/DialogContentText');

var _DialogContentText2 = _interopRequireDefault(_DialogContentText);

var _DialogTitle = require('@material-ui/core/DialogTitle');

var _DialogTitle2 = _interopRequireDefault(_DialogTitle);

var _EnhancedTextField = require('./EnhancedTextField');

var _EnhancedTextField2 = _interopRequireDefault(_EnhancedTextField);

var _DataContainer = require('./DataContainer');

var _DataContainer2 = _interopRequireDefault(_DataContainer);

var _reactSwipeableViews = require('react-swipeable-views');

var _reactSwipeableViews2 = _interopRequireDefault(_reactSwipeableViews);

var _reactRecaptcha = require('react-recaptcha');

var _reactRecaptcha2 = _interopRequireDefault(_reactRecaptcha);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

//recaptcha hooks
var captchaLoadCallback = function captchaLoadCallback() {};
var verifyCaptchaCallback = function verifyCaptchaCallback(response) {
	window.atVAl(true);
};

var ContactForm = function (_React$PureComponent) {
	_inherits(ContactForm, _React$PureComponent);

	function ContactForm(props) {
		_classCallCheck(this, ContactForm);

		var _this = _possibleConstructorReturn(this, (ContactForm.__proto__ || Object.getPrototypeOf(ContactForm)).call(this, props));

		_this.handleSubmitTap = function () {
			if (_this.formIsValid()) {
				_this.sendValidMail();
			} else {
				_this.setState({
					errorDialogOpen: true,
					errorDialogText: 'Please fix the errors on the form.'
				});
			}
		};

		_this.handleSendAnotherTap = function () {
			_this.resetForm();
			_this.setState({
				currentView: 0
			});
		};

		_this.handleTextFieldChange = function (e) {
			_this.setState(_defineProperty({}, e.target.name, e.target.value));
		};

		_this.registerValidatingInput = function (inputField) {
			_this.validatingInputs.indexOf(inputField) < 0 && _this.validatingInputs.push(inputField);
		};

		_this.handleToggleErrorDialog = function () {
			_this.setState(function (prevState) {
				return { errorDialogOpen: !prevState.errorDialogOpen };
			});
		};

		_this.state = {
			firstNameField: '',
			lastNameField: '',
			emailField: '',
			mailBodyField: '',
			errorDialogOpen: false,
			errorDialogText: '',
			currentView: 0,
			humanVerified: false
		};
		_this.validatingInputs = [];
		return _this;
	}

	_createClass(ContactForm, [{
		key: 'componentWillMount',
		value: function componentWillMount() {
			var _this2 = this;

			window.atVAl = function (verified) {
				_this2.setState({ humanVerified: verified });
			};
		}
	}, {
		key: 'resetForm',
		value: function resetForm() {
			this.setState({
				firstNameField: '',
				lastNameField: '',
				emailField: '',
				mailBodyField: '',
				humanVerified: false
			});
		}
	}, {
		key: 'sendValidMail',
		value: function sendValidMail() {

			var that = this;

			var subject = "Contact From " + this.state.firstNameField + ' ' + this.state.lastNameField;
			var dc = new _DataContainer2.default();
			var action = "/api/v1/SendMail";
			var parameters = [{ id: "from", value: this.state.emailField }, { id: "to", value: this.props.recipientEmail }, { id: "subject", value: subject }, { id: "mailBody", value: this.state.mailBodyField }, { id: "firstName", value: this.state.firstNameField }, { id: "lastName", value: this.state.lastNameField }];
			dc.GET("/api/v1/SendMail", parameters, function (data) {
				that.setState({
					currentView: 1
				});
			}, function (error) {
				that.setState({
					errorDialogOpen: true,
					errorDialogText: 'Error: ' + error
				});
			});
		}
	}, {
		key: 'formIsValid',
		value: function formIsValid() {
			var validForm = true;
			this.validatingInputs.forEach(function (input) {
				if (!input.fieldIsValid()) {
					validForm = false;
				}
			});
			return validForm;
		}
	}, {
		key: 'render',
		value: function render() {
			return _react2.default.createElement(
				'div',
				null,
				_react2.default.createElement(
					_reactSwipeableViews2.default,
					{ index: this.state.currentView },
					_react2.default.createElement(
						'div',
						{ style: { overflow: "hidden" } },
						_react2.default.createElement(_EnhancedTextField2.default, { name: 'firstNameField',
							value: this.state.firstNameField,
							helperText: 'First Name',
							floatingLabelText: 'First Name',
							isRequired: true,
							fullWidth: true,
							requiredErrorText: 'Your name is required',
							onChange: this.handleTextFieldChange,
							onFormRegister: this.registerValidatingInput }),
						_react2.default.createElement(_EnhancedTextField2.default, { name: 'lastNameField',
							value: this.state.lastNameField,
							helperText: 'Last Name',
							floatingLabelText: 'Last Name',
							isRequired: true,
							fullWidth: true,
							requiredErrorText: 'Your last name is required',
							onChange: this.handleTextFieldChange,
							onFormRegister: this.registerValidatingInput }),
						_react2.default.createElement(_EnhancedTextField2.default, { name: 'emailField',
							value: this.state.emailField,
							helperText: 'Email',
							floatingLabelText: 'Email',
							fullWidth: true,
							isRequired: true,
							validationType: 'email',
							formatErrorText: 'Please enter a valid email address',
							requiredErrorText: 'Your contact email is required',
							onChange: this.handleTextFieldChange,
							onFormRegister: this.registerValidatingInput }),
						_react2.default.createElement(_EnhancedTextField2.default, { name: 'mailBodyField',
							value: this.state.mailBodyField,
							helperText: 'Comment',
							floatingLabelText: 'Comment',
							multiline: true,
							rows: 4,
							isRequired: true,
							requiredErrorText: 'A comment is required',
							fullWidth: true,
							onChange: this.handleTextFieldChange,
							onFormRegister: this.registerValidatingInput }),
						this.state.humanVerified || !this.props.useRecaptcha ? _react2.default.createElement(
							_Button2.default,
							{
								label: 'Submit',
								color: 'primary',
								onClick: this.handleSubmitTap },
							'Submit'
						) : _react2.default.createElement(_reactRecaptcha2.default, {
							style: { maxWidth: '100%' },
							render: 'explicit',
							sitekey: '6Lfgbw4UAAAAALo2c-sShjsMqKg4AR1j4I3yFA6D',
							verifyCallback: verifyCaptchaCallback,
							onloadCallback: captchaLoadCallback })
					),
					_react2.default.createElement(
						'div',
						null,
						_react2.default.createElement(
							'div',
							{ style: {
									padding: 10,
									font: '17px/1 "Oxygen", sans-serif',
									color: '#7c7c7c',
									lineHeight: 1.5,
									fontWeight: 'bold'
								} },
							'Message sent succesfully!'
						),
						_react2.default.createElement(
							_Button2.default,
							{
								onClick: this.handleSendAnotherTap },
							'Go Back'
						)
					)
				),
				_react2.default.createElement(
					_Dialog2.default,
					{ onClose: this.handleToggleErrorDialog,
						open: this.state.errorDialogOpen,
						'aria-labelledby': 'dialog-title' },
					_react2.default.createElement(
						_DialogTitle2.default,
						{ id: 'dialog-title' },
						'Error'
					),
					_react2.default.createElement(
						_DialogContent2.default,
						null,
						_react2.default.createElement(
							_DialogContentText2.default,
							{ id: 'alert-dialog-description' },
							this.state.errorDialogText
						)
					),
					_react2.default.createElement(
						_DialogActions2.default,
						null,
						_react2.default.createElement(
							_Button2.default,
							{ onClick: this.handleToggleErrorDialog, color: 'primary', autoFocus: true },
							'Ok'
						)
					)
				)
			);
		}
	}]);

	return ContactForm;
}(_react2.default.PureComponent);

ContactForm.propTypes = {
	useRecaptcha: _propTypes2.default.bool,
	recipientEmail: _propTypes2.default.string
};
ContactForm.defaultProps = {
	useRecaptcha: null,
	recipientEmail: 'ricdamayar@gmail.com'
};
exports.default = ContactForm;