'use strict';

Object.defineProperty(exports, "__esModule", {
	value: true
});

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _styles = require('@material-ui/core/styles');

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _CryptoButton = require('../elements/CryptoButton');

var _CryptoButton2 = _interopRequireDefault(_CryptoButton);

var _tinycolor = require('tinycolor2');

var _tinycolor2 = _interopRequireDefault(_tinycolor);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var CryptoButtons = function (_React$PureComponent) {
	_inherits(CryptoButtons, _React$PureComponent);

	function CryptoButtons() {
		_classCallCheck(this, CryptoButtons);

		return _possibleConstructorReturn(this, (CryptoButtons.__proto__ || Object.getPrototypeOf(CryptoButtons)).apply(this, arguments));
	}

	_createClass(CryptoButtons, [{
		key: 'getStyles',
		value: function getStyles() {

			var palette = this.props.theme.palette;

			var backColor = palette.footerBackgroundColor || palette.primary1Color;

			var styles = {
				container: {},
				icons: {
					position: 'relative',
					display: 'inline-block',
					background: backColor,
					borderRadius: '4em',
					padding: '0.35em 0.75em 0.35em 0.75em',
					fontSize: '1.25em',
					cursor: 'default'
				},
				label: {
					display: "inline-block"
				}
			};
			return styles;
		}
	}, {
		key: 'render',
		value: function render() {
			var styles = this.getStyles();
			return _react2.default.createElement(
				'div',
				null,
				_react2.default.createElement(
					'ul',
					{ className: 'icons', style: styles.icons },
					_react2.default.createElement(
						'div',
						{ style: styles.label },
						'Donate:'
					),
					this.props.cryptoLinks.map(function (button, i) {
						return _react2.default.createElement(_CryptoButton2.default, _extends({}, button, { key: i }));
					})
				)
			);
		}
	}]);

	return CryptoButtons;
}(_react2.default.PureComponent);

CryptoButtons.propTypes = {
	cryptoLinks: _propTypes2.default.array
};
CryptoButtons.defaultProps = {
	cryptoLinks: []
};
exports.default = (0, _styles.withTheme)()(CryptoButtons);