'use strict';

Object.defineProperty(exports, "__esModule", {
	value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _reactBootstrap = require('react-bootstrap');

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _modalShim = require('./modal-shim');

var _modalShim2 = _interopRequireDefault(_modalShim);

var _reactCopyToClipboard = require('react-copy-to-clipboard');

var _Snackbar = require('@material-ui/core/Snackbar');

var _Snackbar2 = _interopRequireDefault(_Snackbar);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var CryptoDonationModal = function (_React$PureComponent) {
	_inherits(CryptoDonationModal, _React$PureComponent);

	function CryptoDonationModal(props) {
		_classCallCheck(this, CryptoDonationModal);

		var _this = _possibleConstructorReturn(this, (CryptoDonationModal.__proto__ || Object.getPrototypeOf(CryptoDonationModal)).call(this, props));

		_this.onAddressCopy = function () {
			_this.setState({ copiedToClipboard: true });
		};

		_this.handleRequestClose = function () {
			_this.setState({ copiedToClipboard: false });
		};

		_this.state = {
			copiedToClipboard: false
		};
		return _this;
	}

	_createClass(CryptoDonationModal, [{
		key: 'getStyles',
		value: function getStyles() {
			var styles = {
				icon: {
					width: "100%",
					maxWidth: 200
				},
				heading: {
					textAlign: "center"
				},
				address: {
					fontWeight: "bold",
					fontSize: "1.1em",
					display: 'inline-block'
				},
				coinicon: {
					width: 25,
					paddingRight: 5,
					verticalAlign: "middle"
				},
				copyClipboardButton: {
					display: 'inline-block',
					fontFamily: 'FontAwesome',
					fontSize: '1.25em',
					textDecoration: 'none',
					fontStyle: 'normal',
					fontWeight: 'normal',
					lineHeight: 1,
					WebkitFontSmoothing: 'antialiased',
					MozOsxFontSmoothing: 'grayscale',
					paddingLeft: 7
				}
			};
			return styles;
		}
	}, {
		key: 'render',
		value: function render() {

			var styles = this.getStyles();

			return _react2.default.createElement(
				'div',
				null,
				_react2.default.createElement(
					_modalShim2.default,
					{ show: this.props.show, onHide: this.props.onHide, 'aria-labelledby': 'contained-modal-title-sm' },
					_react2.default.createElement(
						_modalShim2.default.Header,
						{ closeButton: true },
						_react2.default.createElement(
							_modalShim2.default.Title,
							{ id: 'contained-modal-title-sm' },
							_react2.default.createElement(_reactBootstrap.Image, { src: this.props.icon,
								style: styles.coinicon }),
							_react2.default.createElement(
								'div',
								{ style: { display: 'inline-block', verticalAlign: "middle" } },
								'Donate ',
								this.props.name
							)
						)
					),
					_react2.default.createElement(
						_modalShim2.default.Body,
						{ style: { textAlign: "center" } },
						_react2.default.createElement(_reactBootstrap.Image, { src: this.props.qrCode,
							style: styles.icon }),
						_react2.default.createElement(
							'div',
							null,
							_react2.default.createElement(
								'div',
								{ style: styles.address },
								this.props.address
							),
							_react2.default.createElement(
								_reactCopyToClipboard.CopyToClipboard,
								{ text: this.props.address,
									onCopy: this.onAddressCopy },
								_react2.default.createElement(
									_reactBootstrap.OverlayTrigger,
									{ placement: 'top', overlay: _react2.default.createElement(
											_reactBootstrap.Tooltip,
											{ id: 'tooltip' },
											_react2.default.createElement(
												'strong',
												null,
												'Copy to clipboard.'
											)
										) },
									_react2.default.createElement('div', { style: styles.copyClipboardButton, className: 'fa-clipboard' })
								)
							)
						),
						_react2.default.createElement(
							'div',
							null,
							'Sending tokens to this address other than ',
							this.props.coin,
							' will result in your funds being lost.'
						)
					)
				),
				_react2.default.createElement(_Snackbar2.default, { open: this.state.copiedToClipboard,
					message: 'Address copied to clipboard.',
					autoHideDuration: 2000,
					onRequestClose: this.handleRequestClose })
			);
		}
	}]);

	return CryptoDonationModal;
}(_react2.default.PureComponent);

CryptoDonationModal.propTypes = {
	qrCode: _propTypes2.default.string,
	address: _propTypes2.default.string,
	name: _propTypes2.default.string,
	show: _propTypes2.default.bool
};
CryptoDonationModal.defaultProps = {
	qrCode: _propTypes2.default.string,
	address: "(missing)",
	name: "crypto",
	show: false
};
exports.default = CryptoDonationModal;