'use strict';

Object.defineProperty(exports, "__esModule", {
	value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _reactLoading = require('react-loading');

var _reactLoading2 = _interopRequireDefault(_reactLoading);

var _axios = require('axios');

var _axios2 = _interopRequireDefault(_axios);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var DataContainer = function (_React$PureComponent) {
	_inherits(DataContainer, _React$PureComponent);

	function DataContainer(props) {
		_classCallCheck(this, DataContainer);

		var _this = _possibleConstructorReturn(this, (DataContainer.__proto__ || Object.getPrototypeOf(DataContainer)).call(this, props));

		_this.equalRequests = function (a, b) {
			if (a.action !== b.action) return false;

			if (JSON.stringify(a.parameters) !== JSON.stringify(a.parameters)) return false;

			return true;
		};

		_this.state = {
			data: [],
			isLoading: true,
			hasError: false
		};
		return _this;
	}

	_createClass(DataContainer, [{
		key: 'componentWillMount',
		value: function componentWillMount() {
			this.getData();
		}
	}, {
		key: 'componentWillUpdate',
		value: function componentWillUpdate(nextProps, nextState) {
			if (!this.equalRequests(nextProps, this.props)) this.getData();
		}
	}, {
		key: 'getData',
		value: function getData() {
			if (!this.props || this.props == null) return;

			var that = this;
			this.GET(this.props.action, this.props.parameters, function (data) {
				that.setState({
					data: data,
					isLoading: false,
					hasError: false
				});
			}, function (error) {
				that.setState({
					data: error,
					isLoading: false,
					hasError: true
				});
				//console.log(error);
			});
		}
	}, {
		key: 'GET',
		value: function GET(action, parameters, onSuccess, onError) {

			var host = window.location.protocol + "//" + window.location.hostname + (window.location.hostname.toLowerCase().indexOf('localhost') >= 0 ? ":4000" : window.location.port ? ":" + window.location.port : "");

			if (!action || action === null) action = '/';else if (!action.startsWith('/')) action = "/" + action;

			var parameterString = '';
			if (parameters && parameters != null && parameters.length > 0) {
				parameterString += "?";
				for (var i = 0, l = parameters.length; i < l; i++) {
					var currPar = parameters[i];
					parameterString += currPar.id + "=" + encodeURI(currPar.value) + "&";
				}
				parameterString = parameterString.substr(0, parameterString.length - 1);
			}

			var fullRequest = host + action + parameterString;
			var that = this;

			_axios2.default.get(fullRequest).then(function (response) {
				if (response.status === 200) {
					onSuccess && onSuccess(response.data);
				} else {
					onError && onError(response);
				}
			}).catch(function (error) {
				onError && onError(error);
			});
		}
	}, {
		key: 'render',
		value: function render() {
			return _react2.default.createElement(
				'div',
				null,
				_react2.default.createElement(
					'div',
					{ style: { textAlign: 'center', display: this.state.isLoading ? "" : "none" } },
					_react2.default.createElement(
						'div',
						{ style: { width: 64, height: 64, marginLeft: 'auto', marginRight: 'auto' } },
						_react2.default.createElement(_reactLoading2.default, { type: 'spin', color: '#000' })
					)
				),
				!this.state.isLoading && this.props.showRawData && _react2.default.createElement(
					'pre',
					null,
					JSON.stringify(this.state.data, null, 4)
				),
				!this.state.isLoading && !this.state.hasError && this.props.resultRender && this.props.resultRender(this.state.data),
				!this.state.isLoading && this.state.hasError && this.props.errorRender && this.props.errorRender(this.state.data)
			);
		}
	}]);

	return DataContainer;
}(_react2.default.PureComponent);

exports.default = DataContainer;