'use strict';

Object.defineProperty(exports, "__esModule", {
	value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _TextField = require('@material-ui/core/TextField');

var _TextField2 = _interopRequireDefault(_TextField);

var _validator = require('validator');

var _validator2 = _interopRequireDefault(_validator);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

//import textMaskCore from 'text-mask-core';
var textMaskCore = require('text-mask-core');

var EnhancedTextField = function (_React$PureComponent) {
	_inherits(EnhancedTextField, _React$PureComponent);

	function EnhancedTextField(props) {
		_classCallCheck(this, EnhancedTextField);

		var _this = _possibleConstructorReturn(this, (EnhancedTextField.__proto__ || Object.getPrototypeOf(EnhancedTextField)).call(this, props));

		_this.handleChange = function (e) {

			var currVal = e.target.value;

			if (_this.props.mask != null && _this.props.mask.length > 0) {
				var maskResults = textMaskCore.conformToMask(currVal, _this.props.mask, { guide: false });
				currVal = maskResults.conformedValue;
			}

			_this.setState({ value: currVal });

			_this.validateIsRequired(currVal) && _this.validateFormat(currVal);

			_this.props.onChange && _this.props.onChange({ target: { name: e.target.name, value: currVal } });
		};

		_this.state = {
			errorText: ''
		};
		return _this;
	}

	_createClass(EnhancedTextField, [{
		key: 'componentWillMount',
		value: function componentWillMount() {
			this.props.onFormRegister && this.props.onFormRegister(this);
		}
	}, {
		key: 'componentDidMount',
		value: function componentDidMount() {
			if (this.props.mask != null && this.props.mask.length > 0) {
				console.log(textMaskCore);
			}
		}
	}, {
		key: 'validateIsRequired',
		value: function validateIsRequired(value) {
			if (!this.props.isRequired || value && value.length > 0) {
				this.setState({ errorText: "" });
				return true;
			} else {
				this.setState({ errorText: this.props.requiredErrorText });
				return false;
			}
		}
	}, {
		key: 'validateFormat',
		value: function validateFormat(value) {

			if (this.props.validationType && this.props.validationType.length > 0 && value != null && value.length > 0) {

				var isValid = true;
				switch (this.props.validationType) {
					case "email":
						isValid = _validator2.default.isEmail(value);
						break;
					case "numeric":
						isValid = _validator2.default.isNumeric(value);
						break;
					case "phone":
						isValid = _validator2.default.isMobilePhone(value);
						break;
					default:
						break;
				}
				if (isValid) {
					this.setState({ errorText: "" });
					return true;
				} else {
					this.setState({ errorText: this.props.formatErrorText });
					return false;
				}
			} else {
				this.setState({ errorText: "" });
				return true;
			}
		}
	}, {
		key: 'fieldIsValid',
		value: function fieldIsValid() {
			return this.validateIsRequired(this.props.value) && this.validateFormat(this.props.value);
		}
	}, {
		key: 'render',
		value: function render() {
			return _react2.default.createElement(_TextField2.default, { id: this.props.id,
				className: this.props.className,
				defaultValue: this.props.defaultValue,
				disabled: this.props.disabled,
				error: this.state.errorText && this.state.errorText.length > 0 ? true : false,
				label: this.state.errorText,
				fullWidth: this.props.fullWidth,
				helperText: this.props.helperText,
				multiline: this.props.multiline,
				margin: 'normal',
				name: this.props.name,
				rows: this.props.rows,
				rowsMax: this.props.rowsMax,
				style: this.props.style,
				type: this.props.type,
				onChange: this.handleChange,
				value: this.props.value
			});
		}
	}]);

	return EnhancedTextField;
}(_react2.default.PureComponent);

exports.default = EnhancedTextField;