'use strict';

Object.defineProperty(exports, "__esModule", {
	value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _DataContainer = require('./DataContainer');

var _DataContainer2 = _interopRequireDefault(_DataContainer);

var _EventThumbView = require('./EventThumbView');

var _EventThumbView2 = _interopRequireDefault(_EventThumbView);

var _Utils = require('../Utils');

var _Utils2 = _interopRequireDefault(_Utils);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var EventListView = function (_React$PureComponent) {
	_inherits(EventListView, _React$PureComponent);

	function EventListView() {
		var _ref;

		var _temp, _this, _ret;

		_classCallCheck(this, EventListView);

		for (var _len = arguments.length, args = Array(_len), _key = 0; _key < _len; _key++) {
			args[_key] = arguments[_key];
		}

		return _ret = (_temp = (_this = _possibleConstructorReturn(this, (_ref = EventListView.__proto__ || Object.getPrototypeOf(EventListView)).call.apply(_ref, [this].concat(args))), _this), _this.renderMergedEvents = function (events) {

			var that = _this;

			events = that.processEventsForPresentation(events);

			if (that.props.maxResults > 0 && events && events.length > 0) {
				events = events.slice(0, that.props.maxResults);
			}

			return _react2.default.createElement(
				'div',
				null,
				events.length > 0 && events.map(function (event, i) {

					//return <div key={i} style={{ background:"red", width:100, height:100, padding:30}} />

					return _react2.default.createElement(
						'div',
						{ style: { marginBottom: 15 } },
						_react2.default.createElement(_EventThumbView2.default, { key: i, data: event, match: that.props.match, targetPageRoot: that.props.targetPageRoot })
					);
				}),
				events.length <= 0 && _react2.default.createElement(
					'div',
					null,
					_react2.default.createElement('div', { dangerouslySetInnerHTML: {
							__html: '\n\t\t\t\t\t\t\t<style>\n\t\t\t\t\t\t\t\t.ghostEventList { display:none;}\n\t\t\t\t\t\t\t</style>\n\t\t\t\t\t\t\t'
						} }),
					_react2.default.createElement(
						'div',
						{ style: {
								fontSize: '26px',
								textAlign: 'center',
								padding: 30
							} },
						'There are currently no events to show. Please check again later.'
					)
				)
			);
		}, _temp), _possibleConstructorReturn(_this, _ret);
	}

	_createClass(EventListView, [{
		key: 'processFBEventsForMerging',
		value: function processFBEventsForMerging(fbEvents) {

			if (!fbEvents || fbEvents == null || fbEvents.length <= 0) return [];

			var mergingEvents = [];

			var that = this;

			fbEvents.forEach(function (event) {

				var dateToFormat = _Utils2.default.getValidDate(event.start_time);

				var ev = {
					id: event.id,
					description: {
						text: event.description,
						html: event.description
					},
					name: {
						text: event.name,
						html: event.name
					},
					start: {
						utc: event.start_time
					},
					raw: event,
					fbEvent: true
				};
				mergingEvents.push(ev);
			});

			return mergingEvents;
		}
	}, {
		key: 'processEventsForPresentation',
		value: function processEventsForPresentation(events) {

			var that = this;

			if (!events || events.length <= 0) return events;

			console.log(events);

			events = events.filter(function (event) {
				var today = new Date(Date.now());
				var yesterdayCompareDate = new Date(Date.now());
				var yesterday = yesterdayCompareDate.setDate(yesterdayCompareDate.getDate() - 1);

				console.log("1");
				var startDate = _Utils2.default.getValidDate(event.start.utc);

				console.log("1");
				//past events
				if (that.props.pastEvents && !that.props.nextEvents) return startDate <= yesterday || event.status && event.status == "canceled";

				//future events
				if (!that.props.pastEvents && that.props.nextEvents) return startDate > today && (!event.status || event.status && event.status != "canceled");

				//all events
				if (that.props.pastEvents && that.props.nextEvents) return true;

				//no events
				if (!that.props.pastEvents && !that.props.nextEvents) return false;
			});

			events = events.filter(function (event, i, a) {

				//always prioritize eventbrite events since they will contain
				//a register link which is more helpful than the fb events.
				if (!event.fbEvent) return true;

				for (var j = 0; j < a.length; j++) {
					if (j === i) continue;

					if (a[j].name.text === event.name.text) return false;
				}
				return true;
			});

			events = events.sort(function (a, b) {
				var dateA = _Utils2.default.getValidDate(a.start.utc);
				var dateB = _Utils2.default.getValidDate(b.start.utc);

				//future events
				//show earliest first
				if (!that.props.pastEvents && that.props.nextEvents) return dateA < dateB ? -1 : dateA > dateB ? 1 : 0;

				return dateA < dateB ? 1 : dateA > dateB ? -1 : 0;
			});

			return events;
		}
	}, {
		key: 'render',
		value: function render() {

			var that = this;

			return _react2.default.createElement(_DataContainer2.default, { action: 'api/v1/GetEventbriteEvents',
				parameters: [{ id: "additionalUsers", value: this.props.aditionalUsers }],
				resultRender: function resultRender(data) {
					//console.log(data);

					return _react2.default.createElement(_DataContainer2.default, { action: 'api/v1/GetFacebookEvents',
						resultRender: function resultRender(fbdata) {

							console.log(fbdata);

							var processedFbEvents = [];
							if (fbdata.events && fbdata.events.data) processedFbEvents = that.processFBEventsForMerging(fbdata.events.data);

							var mergedEvents = data.events.concat(processedFbEvents);

							return that.renderMergedEvents(mergedEvents);
						}, errorRender: function errorRender(error) {
							console.log(error);
							return that.renderMergedEvents(data.events);
						}
					});
				} });
		}
	}]);

	return EventListView;
}(_react2.default.PureComponent);

EventListView.propTypes = {
	aditionalUsers: _propTypes2.default.array,
	pastEvents: _propTypes2.default.bool,
	nextEvents: _propTypes2.default.bool,
	maxResults: _propTypes2.default.number,
	targetPageRoot: _propTypes2.default.string
};
EventListView.defaultProps = {
	aditionalUsers: [],
	pastEvents: false,
	nextEvents: true,
	maxResults: -1,
	targetPageRoot: ""
};
exports.default = EventListView;