'use strict';

Object.defineProperty(exports, "__esModule", {
	value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _reactBootstrap = require('react-bootstrap');

var _Paper = require('@material-ui/core/Paper');

var _Paper2 = _interopRequireDefault(_Paper);

var _dateformat = require('dateformat');

var _dateformat2 = _interopRequireDefault(_dateformat);

var _DataContainer = require('./DataContainer');

var _DataContainer2 = _interopRequireDefault(_DataContainer);

var _Utils = require('../Utils');

var _Utils2 = _interopRequireDefault(_Utils);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var EventThumbViewAnimationCSS = function (_React$PureComponent) {
	_inherits(EventThumbViewAnimationCSS, _React$PureComponent);

	function EventThumbViewAnimationCSS() {
		_classCallCheck(this, EventThumbViewAnimationCSS);

		return _possibleConstructorReturn(this, (EventThumbViewAnimationCSS.__proto__ || Object.getPrototypeOf(EventThumbViewAnimationCSS)).apply(this, arguments));
	}

	_createClass(EventThumbViewAnimationCSS, [{
		key: 'render',
		value: function render() {

			return _react2.default.createElement('div', { dangerouslySetInnerHTML: {
					__html: '\n\t\t\t\t<style>\n\t\t\t\t\t.kokolib_event_thumbview {\n\t\t\t\t\t\t-webkit-transition: 1s;\n\t\t\t\t\t\t-moz-transition: 1s;\n\t\t\t\t\t\t-o-transition: 1s;\n\t\t\t\t\t\ttransition: 1s;\n\t\t\t\t\t}\n\n\t\t\t\t\t.kokolib_event_thumbview.focused {\n\t\t\t\t\t\ttransform:scale(1.03) !important;\n\t\t\t\t\t}\n\n\t\t\t\t</style>\n\t\t\t\t'
				} });
		}
	}]);

	return EventThumbViewAnimationCSS;
}(_react2.default.PureComponent);

var EventThumbView = function (_React$PureComponent2) {
	_inherits(EventThumbView, _React$PureComponent2);

	function EventThumbView(props) {
		_classCallCheck(this, EventThumbView);

		var _this2 = _possibleConstructorReturn(this, (EventThumbView.__proto__ || Object.getPrototypeOf(EventThumbView)).call(this, props));

		_this2.onHoverEnter = function () {
			_this2.setState({
				focused: true
			});
		};

		_this2.onHoverLeave = function () {
			_this2.setState({
				focused: false
			});
		};

		_this2.state = {
			focused: false
		};
		return _this2;
	}

	_createClass(EventThumbView, [{
		key: 'getStyles',
		value: function getStyles() {
			var styles = {
				paperStyle: {
					margin: 20
				},
				logoStyle: {
					width: '100%'
				},
				descriptionBody: {
					marginTop: 10,
					width: '100%'
				},
				eventTitle: {
					fontWeight: 'bold',
					fontSize: 20,
					color: '#000'

				},
				eventDate: {
					fontSize: 18
				}
			};
			return styles;
		}
	}, {
		key: 'render',
		value: function render() {

			var styles = this.getStyles();

			var ellipsedText = "";
			if (this.props.data.description.text && this.props.data.description.text.length > 0) ellipsedText = this.props.data.description.text.substring(0, 200) + "...";

			var startDateTime = (0, _dateformat2.default)(_Utils2.default.getValidDate(this.props.data.start.utc), "dddd, mmmm dS, yyyy");

			//console.log(this.props.data);

			var linkUrl = "";

			if (this.props.match && this.props.match.url && this.props.match.url.length > 1) {
				linkUrl += this.props.match.url + '/';
			}

			if (this.props.targetPageRoot && this.props.targetPageRoot.length > 0) {
				linkUrl += this.props.targetPageRoot + '/';
			}

			if (this.props.data.fbEvent) linkUrl += "fb";

			linkUrl += this.props.data.id;

			linkUrl = linkUrl.replace("//", "/");

			var componentClasses = ['kokolib_event_thumbview'];
			if (this.state.focused) {
				componentClasses.push('focused');
			}

			console.log("render");

			//return <div style={{ background:"red", width:100, height:100, padding:30}} />
			return _react2.default.createElement(
				'div',
				null,
				_react2.default.createElement(EventThumbViewAnimationCSS, null),
				_react2.default.createElement(
					'a',
					{ href: linkUrl },
					_react2.default.createElement(
						'div',
						{ className: componentClasses.join(' '),
							onMouseEnter: this.onHoverEnter,
							onMouseLeave: this.onHoverLeave },
						_react2.default.createElement(
							_Paper2.default,
							{ style: styles.paperStyle, elevation: 3 },
							false && _react2.default.createElement(
								'pre',
								null,
								JSON.stringify(this.props.data, null, 4)
							),
							_react2.default.createElement(
								_reactBootstrap.Row,
								null,
								_react2.default.createElement(
									_reactBootstrap.Col,
									{ xs: 12, sm: 4, md: 4, lg: 2, lgHidden: true },
									this.props.data.logo && !this.props.data.fbEvent && _react2.default.createElement(_reactBootstrap.Image, { src: this.props.data.logo.url, style: styles.logoStyle }),
									this.props.data.fbEvent && _react2.default.createElement(_DataContainer2.default, { action: '/api/v1/GetFacebookEventPicture',
										parameters: [{ id: "eventId", value: this.props.data.id }],
										resultRender: function resultRender(pictureData) {

											if (!pictureData.cover) return _react2.default.createElement('div', null);

											return _react2.default.createElement('div', { style: {
													width: '100%',
													height: 250,
													backgroundImage: 'url("' + pictureData.cover.source + '")',
													backgroundSize: 'cover',
													backgroundRepeat: 'no-repeat',
													backgroundPosition: 'center'
												} });

											return _react2.default.createElement(_reactBootstrap.Image, { src: pictureData.cover.source, style: styles.logoStyle });
										} })
								),
								_react2.default.createElement(
									_reactBootstrap.Col,
									{ xs: 12, sm: 8, md: 8, lg: 12 },
									_react2.default.createElement(
										_reactBootstrap.Row,
										null,
										_react2.default.createElement(
											_reactBootstrap.Col,
											{ xsHidden: true, smHidden: true, mdHidden: true, lg: 3 },
											!this.props.data.fbEvent && this.props.data.logo && this.props.data.logo.url && _react2.default.createElement(_reactBootstrap.Image, { src: this.props.data.logo.url, style: styles.logoStyle }),
											this.props.data.fbEvent && _react2.default.createElement(_DataContainer2.default, { action: '/api/v1/GetFacebookEventPicture',
												parameters: [{ id: "eventId", value: this.props.data.id }],
												resultRender: function resultRender(pictureData) {

													if (!pictureData.cover) return _react2.default.createElement('div', null);

													console.log(pictureData.cover.source);

													return _react2.default.createElement('div', { style: {
															width: '100%',
															height: 250,
															backgroundImage: 'url("' + pictureData.cover.source + '")',
															backgroundSize: 'cover',
															backgroundRepeat: 'no-repeat',
															backgroundPosition: 'center'
														} });

													return _react2.default.createElement(_reactBootstrap.Image, { src: pictureData.cover.source, style: styles.logoStyle });
												} })
										),
										_react2.default.createElement(
											_reactBootstrap.Col,
											{ xs: 12, lg: 4 },
											_react2.default.createElement(
												'div',
												{ style: { padding: 10 } },
												_react2.default.createElement(
													'div',
													{ style: styles.eventTitle, className: 'kokolib_event_thumb_title' },
													this.props.data.name.text
												),
												_react2.default.createElement(
													'div',
													{ style: styles.eventDate, className: 'kokolib_event_thumb_date' },
													startDateTime
												),
												this.props.data.status == 'canceled' && _react2.default.createElement(
													'div',
													{ style: { color: "#ab003c" } },
													'CANCELED'
												)
											)
										),
										_react2.default.createElement(
											_reactBootstrap.Col,
											{ xsHidden: true, mdHidden: true, smHidden: true, lg: 5 },
											_react2.default.createElement(
												'div',
												{ style: styles.descriptionBody, className: 'kokolib_event_thumb_description' },
												ellipsedText
											)
										)
									),
									_react2.default.createElement(
										_reactBootstrap.Row,
										null,
										_react2.default.createElement(
											_reactBootstrap.Col,
											{ xs: 12, lgHidden: true },
											_react2.default.createElement('hr', { style: { margin: 0 } }),
											_react2.default.createElement(
												'div',
												{ style: { padding: "5px 25px" } },
												_react2.default.createElement(
													'div',
													{ style: styles.descriptionBody, className: 'kokolib_event_thumb_description' },
													ellipsedText
												)
											)
										)
									)
								)
							)
						)
					)
				)
			);
		}
	}]);

	return EventThumbView;
}(_react2.default.PureComponent);

exports.default = EventThumbView;