'use strict';

Object.defineProperty(exports, "__esModule", {
	value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _reactBootstrap = require('react-bootstrap');

var _Paper = require('@material-ui/core/Paper');

var _Paper2 = _interopRequireDefault(_Paper);

var _dateformat = require('dateformat');

var _dateformat2 = _interopRequireDefault(_dateformat);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _reactMetaTags = require('react-meta-tags');

var _reactMetaTags2 = _interopRequireDefault(_reactMetaTags);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var EventbriteEventView = function (_React$PureComponent) {
	_inherits(EventbriteEventView, _React$PureComponent);

	function EventbriteEventView() {
		_classCallCheck(this, EventbriteEventView);

		return _possibleConstructorReturn(this, (EventbriteEventView.__proto__ || Object.getPrototypeOf(EventbriteEventView)).apply(this, arguments));
	}

	_createClass(EventbriteEventView, [{
		key: 'getStyles',
		value: function getStyles() {
			var styles = {
				paperStyle: {
					margin: 0
				},
				logoStyle: {
					width: '100%'
				}
			};
			return styles;
		}
	}, {
		key: 'render',
		value: function render() {

			var styles = this.getStyles();

			var data = this.props.data;

			var startDate = (0, _dateformat2.default)(new Date(data.start.local), "dddd, mmmm dS, yyyy");
			var startDateTime = (0, _dateformat2.default)(new Date(data.start.utc), "h:MM:ss TT");
			var endDateTime = (0, _dateformat2.default)(new Date(data.end.utc), "h:MM:ss TT Z");

			var metaDescription = data.description.text.length > 170 ? data.description.text.substr(0, 160) + "..." : data.description.text;

			var eventImage = data.logo && data.logo.url || '';

			return _react2.default.createElement(
				_Paper2.default,
				{ style: styles.paperStyle, elevation: 3 },
				_react2.default.createElement(
					_reactMetaTags2.default,
					null,
					_react2.default.createElement(
						'title',
						null,
						data.name.text
					),
					_react2.default.createElement('meta', { id: 'meta-description', name: 'description', content: metaDescription }),
					_react2.default.createElement('meta', { id: 'og-title', property: 'og:title', content: data.name.text }),
					_react2.default.createElement('meta', { id: 'og-image', property: 'og:image', content: eventImage })
				),
				_react2.default.createElement(
					_reactBootstrap.Row,
					null,
					_react2.default.createElement(
						_reactBootstrap.Col,
						{ xs: 12, lg: 4 },
						_react2.default.createElement(_reactBootstrap.Image, { src: eventImage, style: styles.logoStyle })
					),
					_react2.default.createElement(
						_reactBootstrap.Col,
						{ xs: 12, lg: 8 },
						_react2.default.createElement(
							'div',
							{ style: { 'padding': '0px 20px' } },
							_react2.default.createElement(
								'h1',
								null,
								data.name.text
							),
							_react2.default.createElement(
								'p',
								null,
								'by ',
								data.organizer.name,
								' '
							)
						),
						data.status == 'canceled' && _react2.default.createElement(
							'div',
							{ style: { padding: 20, fontSize: "1.2em", color: "#ab003c" } },
							'CANCELED'
						)
					)
				),
				_react2.default.createElement('hr', { style: { margin: 0 } }),
				_react2.default.createElement(
					_reactBootstrap.Row,
					null,
					_react2.default.createElement(
						_reactBootstrap.Col,
						{ xs: 12, sm: 12, mdHidden: true, lgHidden: true },
						_react2.default.createElement(
							'div',
							{ style: { padding: 20, paddingTop: 0 } },
							_react2.default.createElement(
								_reactBootstrap.Row,
								null,
								_react2.default.createElement(
									_reactBootstrap.Col,
									{ xs: 12, sm: 6 },
									_react2.default.createElement(
										'h2',
										null,
										_react2.default.createElement(
											'b',
											null,
											'Date and Time'
										)
									),
									_react2.default.createElement(
										'p',
										null,
										_react2.default.createElement(
											'span',
											null,
											startDate
										),
										_react2.default.createElement('br', null),
										_react2.default.createElement(
											'span',
											null,
											startDateTime
										),
										_react2.default.createElement(
											'span',
											null,
											' - '
										),
										_react2.default.createElement(
											'span',
											null,
											endDateTime
										)
									)
								),
								_react2.default.createElement(
									_reactBootstrap.Col,
									{ xs: 12, sm: 6 },
									_react2.default.createElement(
										'h2',
										null,
										_react2.default.createElement(
											'b',
											null,
											'Location'
										)
									),
									_react2.default.createElement(
										'div',
										null,
										data.venue.name
									),
									data.venue.address.localized_multi_line_address_display.map(function (line, i) {
										return _react2.default.createElement(
											'div',
											{ key: i },
											line
										);
									})
								)
							)
						)
					),
					_react2.default.createElement(
						_reactBootstrap.Col,
						{ xs: 12, md: 6, lg: 8 },
						_react2.default.createElement(
							'div',
							{ style: { padding: 20, paddingTop: 0 } },
							_react2.default.createElement(
								'h2',
								null,
								_react2.default.createElement(
									'b',
									null,
									'Description'
								)
							),
							_react2.default.createElement('p', { dangerouslySetInnerHTML: { __html: data.description.html } })
						)
					),
					_react2.default.createElement(
						_reactBootstrap.Col,
						{ xsHidden: true, smHidden: true, sm: 12, md: 6, lg: 4 },
						_react2.default.createElement(
							'div',
							{ style: { padding: 20, paddingTop: 0 } },
							_react2.default.createElement(
								'h2',
								null,
								_react2.default.createElement(
									'b',
									null,
									'Date and Time'
								)
							),
							_react2.default.createElement(
								'p',
								null,
								_react2.default.createElement(
									'span',
									null,
									startDate
								),
								_react2.default.createElement('br', null),
								_react2.default.createElement(
									'span',
									null,
									startDateTime
								),
								_react2.default.createElement(
									'span',
									null,
									' - '
								),
								_react2.default.createElement(
									'span',
									null,
									endDateTime
								)
							),
							_react2.default.createElement('hr', null),
							_react2.default.createElement(
								'h2',
								null,
								_react2.default.createElement(
									'b',
									null,
									'Location'
								)
							),
							_react2.default.createElement(
								'div',
								null,
								data.venue.name
							),
							data.venue.address.localized_multi_line_address_display.map(function (line, i) {
								return _react2.default.createElement(
									'div',
									{ key: i },
									line
								);
							})
						)
					)
				),
				data.status !== 'completed' && _react2.default.createElement(
					'div',
					null,
					_react2.default.createElement('hr', { style: { margin: 0 } }),
					_react2.default.createElement(
						_reactBootstrap.Row,
						null,
						_react2.default.createElement(_reactBootstrap.Col, { xs: 12, sm: 12, md: 6, lg: 8 }),
						_react2.default.createElement(
							_reactBootstrap.Col,
							{ xs: 12, sm: 12, md: 6, lg: 4 },
							data.status != 'canceled' && _react2.default.createElement(
								'div',
								{ style: { padding: 20 } },
								_react2.default.createElement(
									_reactBootstrap.Button,
									{ bsStyle: 'primary', bsSize: 'large', block: true, onClick: function onClick() {
											window.open(data.url + '#tickets', '_blank');
										} },
									'Register'
								)
							),
							data.status == 'canceled' && _react2.default.createElement(
								'div',
								{ style: { padding: 20, color: "#ab003c" } },
								'CANCELED'
							)
						)
					)
				)
			);
		}
	}]);

	return EventbriteEventView;
}(_react2.default.PureComponent);

EventbriteEventView.propTypes = {
	data: _propTypes2.default.object
};
EventbriteEventView.defaultProps = {
	data: {}
};
exports.default = EventbriteEventView;