'use strict';

Object.defineProperty(exports, "__esModule", {
	value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _reactBootstrap = require('react-bootstrap');

var _Paper = require('@material-ui/core/Paper');

var _Paper2 = _interopRequireDefault(_Paper);

var _dateformat = require('dateformat');

var _dateformat2 = _interopRequireDefault(_dateformat);

var _DataContainer = require('./DataContainer');

var _DataContainer2 = _interopRequireDefault(_DataContainer);

var _moment = require('moment');

var _moment2 = _interopRequireDefault(_moment);

var _draftJsImportMarkdown = require('draft-js-import-markdown');

var _draftJsExportHtml = require('draft-js-export-html');

var _reactMetaTags = require('react-meta-tags');

var _reactMetaTags2 = _interopRequireDefault(_reactMetaTags);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var FacebookEventAddressArea = function (_React$PureComponent) {
	_inherits(FacebookEventAddressArea, _React$PureComponent);

	function FacebookEventAddressArea() {
		_classCallCheck(this, FacebookEventAddressArea);

		return _possibleConstructorReturn(this, (FacebookEventAddressArea.__proto__ || Object.getPrototypeOf(FacebookEventAddressArea)).apply(this, arguments));
	}

	_createClass(FacebookEventAddressArea, [{
		key: 'render',
		value: function render() {
			return _react2.default.createElement(
				'div',
				{ style: { padding: 20, paddingTop: 0 } },
				_react2.default.createElement(
					_reactBootstrap.Row,
					null,
					_react2.default.createElement(
						_reactBootstrap.Col,
						{ xs: 12, sm: this.props.place ? 6 : 12 },
						_react2.default.createElement(
							'h2',
							null,
							_react2.default.createElement(
								'b',
								null,
								'Date and Time'
							)
						),
						_react2.default.createElement(
							'p',
							null,
							_react2.default.createElement(
								'span',
								null,
								this.props.startDate
							),
							_react2.default.createElement('br', null),
							_react2.default.createElement(
								'span',
								null,
								this.props.startDateTime
							),
							_react2.default.createElement(
								'span',
								null,
								' - '
							),
							_react2.default.createElement(
								'span',
								null,
								this.props.endDateTime
							)
						)
					),
					this.props.place && _react2.default.createElement(
						_reactBootstrap.Col,
						{ xs: 12, sm: 6 },
						_react2.default.createElement(
							'h2',
							null,
							_react2.default.createElement(
								'b',
								null,
								'Location'
							)
						),
						this.props.place.name && _react2.default.createElement(
							'div',
							null,
							this.props.place.name
						),
						this.props.place.street && _react2.default.createElement(
							'div',
							null,
							this.props.place.street
						),
						_react2.default.createElement(
							'div',
							null,
							this.props.place.city && this.props.place.city + " ",
							this.props.place.state && this.props.place.state + " ",
							this.props.place.zip && ", " + this.props.place.zip
						)
					)
				)
			);
		}
	}]);

	return FacebookEventAddressArea;
}(_react2.default.PureComponent);

var FacebookEventView = function (_React$PureComponent2) {
	_inherits(FacebookEventView, _React$PureComponent2);

	function FacebookEventView(props) {
		_classCallCheck(this, FacebookEventView);

		var _this2 = _possibleConstructorReturn(this, (FacebookEventView.__proto__ || Object.getPrototypeOf(FacebookEventView)).call(this, props));

		_this2.state = {
			description: ""
		};
		return _this2;
	}

	_createClass(FacebookEventView, [{
		key: 'getStyles',
		value: function getStyles() {
			var styles = {
				paperStyle: {
					margin: 0
				},
				logoStyle: {
					width: '100%'
				}
			};
			return styles;
		}
	}, {
		key: 'getValidDate',
		value: function getValidDate(dateString, utc) {
			if (utc) return new Date(_moment2.default.utc(dateString).valueOf());else return new Date((0, _moment2.default)(dateString).valueOf());
		}
	}, {
		key: 'linkify',
		value: function linkify(inputText) {
			var replacedText, replacePattern1, replacePattern2, replacePattern3;

			//URLs starting with http://, https://, or ftp://
			replacePattern1 = /(\b(https?|ftp):\/\/[-A-Z0-9+&@#\/%?=~_|!:,.;]*[-A-Z0-9+&@#\/%=~_|])/gim;
			replacedText = inputText.replace(replacePattern1, '<a href="$1" target="_blank">$1</a>');

			//URLs starting with "www." (without // before it, or it'd re-link the ones done above).
			replacePattern2 = /(^|[^\/])(www\.[\S]+(\b|$))/gim;
			replacedText = replacedText.replace(replacePattern2, '$1<a href="http://$2" target="_blank">$2</a>');

			//Change email addresses to mailto:: links.
			replacePattern3 = /(([a-zA-Z0-9\-\_\.])+@[a-zA-Z\_]+?(\.[a-zA-Z]{2,6})+)/gim;
			replacedText = replacedText.replace(replacePattern3, '<a href="mailto:$1">$1</a>');

			return replacedText;
		}
	}, {
		key: 'render',
		value: function render() {

			var styles = this.getStyles();

			var data = this.props.data;

			var startDate = (0, _dateformat2.default)(this.getValidDate(data.start_time), "dddd, mmmm dS, yyyy");
			var startDateTime = (0, _dateformat2.default)(this.getValidDate(data.start_time), "h:MM:ss TT");
			var endDateTime = (0, _dateformat2.default)(this.getValidDate(data.end_time), "h:MM:ss TT Z");
			var description = data.description;
			var contentState = (0, _draftJsImportMarkdown.stateFromMarkdown)(description);
			var descriptionHtml = (0, _draftJsExportHtml.stateToHTML)(contentState);
			descriptionHtml = this.linkify(descriptionHtml);

			var metaDescription = data.description.length > 170 ? data.description.substr(0, 160) + "..." : data.description;

			return _react2.default.createElement(
				_Paper2.default,
				{ style: styles.paperStyle, elevation: 3 },
				_react2.default.createElement(
					_reactMetaTags2.default,
					null,
					_react2.default.createElement(
						'title',
						null,
						data.name
					),
					_react2.default.createElement('meta', { id: 'meta-description', name: 'description', content: metaDescription }),
					_react2.default.createElement('meta', { id: 'og-title', property: 'og:title', content: data.name })
				),
				_react2.default.createElement(
					_reactBootstrap.Row,
					null,
					_react2.default.createElement(
						_reactBootstrap.Col,
						{ xs: 12, sm: 6, md: 4, lg: 3 },
						_react2.default.createElement(_DataContainer2.default, { action: '/api/v1/GetFacebookEventPicture',
							parameters: [{ id: "eventId", value: data.id }],
							resultRender: function resultRender(pictureData) {

								if (!pictureData.cover) return _react2.default.createElement('div', null);

								return _react2.default.createElement(
									'div',
									null,
									_react2.default.createElement(
										_reactMetaTags2.default,
										null,
										_react2.default.createElement('meta', { id: 'og-image', property: 'og:image', content: pictureData.cover.source })
									),
									_react2.default.createElement('div', { style: {
											width: '100%',
											height: 250,
											backgroundImage: 'url("' + pictureData.cover.source + '")',
											backgroundSize: 'cover',
											backgroundRepeat: 'no-repeat',
											backgroundPosition: 'center'
										} })
								);
							} })
					),
					_react2.default.createElement(
						_reactBootstrap.Col,
						{ xs: 12, sm: 6, md: 8, lg: 9 },
						_react2.default.createElement(
							'div',
							{ style: { 'padding': '0px 20px' } },
							_react2.default.createElement(
								'h1',
								null,
								data.name
							)
						),
						_react2.default.createElement(
							_reactBootstrap.Row,
							null,
							_react2.default.createElement(
								_reactBootstrap.Col,
								{ xsHidden: true, smHidden: true },
								_react2.default.createElement(FacebookEventAddressArea, { startDate: startDate,
									startDateTime: startDateTime,
									endDateTime: endDateTime,
									place: data.place })
							)
						)
					)
				),
				_react2.default.createElement('hr', { style: { margin: 0 } }),
				_react2.default.createElement(
					_reactBootstrap.Row,
					null,
					_react2.default.createElement(
						_reactBootstrap.Col,
						{ xs: 12, sm: 12, mdHidden: true, lgHidden: true },
						_react2.default.createElement(FacebookEventAddressArea, { startDate: startDate,
							startDateTime: startDateTime,
							endDateTime: endDateTime,
							place: data.place })
					),
					_react2.default.createElement(
						_reactBootstrap.Col,
						{ xs: 12, md: 12, lg: 12 },
						_react2.default.createElement(
							'div',
							{ style: { padding: 20, paddingTop: 0 } },
							_react2.default.createElement(
								'h2',
								null,
								_react2.default.createElement(
									'b',
									null,
									'Description'
								)
							),
							_react2.default.createElement('div', { dangerouslySetInnerHTML: { __html: descriptionHtml } })
						)
					)
				)
			);
		}
	}]);

	return FacebookEventView;
}(_react2.default.PureComponent);

FacebookEventView.propTypes = {
	data: _propTypes2.default.object
};
FacebookEventView.defaultProps = {
	data: {}
};
exports.default = FacebookEventView;