'use strict';

Object.defineProperty(exports, "__esModule", {
	value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _DataContainer = require('./DataContainer');

var _DataContainer2 = _interopRequireDefault(_DataContainer);

var _FacebookVideoStream = require('./FacebookVideoStream');

var _FacebookVideoStream2 = _interopRequireDefault(_FacebookVideoStream);

var _Utils = require('../Utils');

var _Utils2 = _interopRequireDefault(_Utils);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var FacebookLiveStream = function (_React$PureComponent) {
	_inherits(FacebookLiveStream, _React$PureComponent);

	function FacebookLiveStream() {
		_classCallCheck(this, FacebookLiveStream);

		return _possibleConstructorReturn(this, (FacebookLiveStream.__proto__ || Object.getPrototypeOf(FacebookLiveStream)).apply(this, arguments));
	}

	_createClass(FacebookLiveStream, [{
		key: 'render',
		value: function render() {

			var that = this;

			return _react2.default.createElement(_DataContainer2.default, { action: 'api/v1/GetFacebookLiveStream',
				resultRender: function resultRender(data) {

					if (!data || !data.data || data.data.length <= 0) {
						return _react2.default.createElement('div', null);
					}
					var liveStreams = data.data.filter(function (stream) {

						//always allow live streams
						if (stream.status === 'LIVE') return true;

						var startDate = _Utils2.default.getValidDate(stream.broadcast_start_time);
						var cutoffDate = startDate.setDate(startDate.getDate() + that.props.daysToLive);
						var today = new Date(Date.now());

						return cutoffDate > today;
					});

					if (!liveStreams || liveStreams.length <= 0) return _react2.default.createElement('div', null);

					var selectedStream = liveStreams[0];

					return _react2.default.createElement(_FacebookVideoStream2.default, { id: selectedStream.id,
						embedHtml: selectedStream.embed_html,
						description: selectedStream.description });
				} });
		}
	}]);

	return FacebookLiveStream;
}(_react2.default.PureComponent);

FacebookLiveStream.propTypes = {
	daysToLive: _propTypes2.default.number
};
FacebookLiveStream.defaultProps = {
	daysToLive: 7
};
exports.default = FacebookLiveStream;