'use strict';

Object.defineProperty(exports, "__esModule", {
	value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _reactDimensions = require('react-dimensions');

var _reactDimensions2 = _interopRequireDefault(_reactDimensions);

var _MeasuredContainer = require('../elements/MeasuredContainer');

var _MeasuredContainer2 = _interopRequireDefault(_MeasuredContainer);

var _DataContainer = require('./DataContainer');

var _DataContainer2 = _interopRequireDefault(_DataContainer);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var FacebookVideoStream = function (_React$PureComponent) {
	_inherits(FacebookVideoStream, _React$PureComponent);

	function FacebookVideoStream() {
		_classCallCheck(this, FacebookVideoStream);

		return _possibleConstructorReturn(this, (FacebookVideoStream.__proto__ || Object.getPrototypeOf(FacebookVideoStream)).apply(this, arguments));
	}

	_createClass(FacebookVideoStream, [{
		key: 'getTargetWidth',
		value: function getTargetWidth(frameHtml) {

			var delimiter = " width=";
			var widthString = frameHtml.substr(frameHtml.indexOf(delimiter) + delimiter.length);

			widthString = widthString.trim().substr(0, frameHtml.indexOf(" ") - 1);
			widthString = widthString.split("\"").join("").split("'").join("");

			return parseInt(widthString);
		}
	}, {
		key: 'getTargetHeight',
		value: function getTargetHeight(frameHtml) {

			var delimiter = " height=";
			var heightString = frameHtml.substr(frameHtml.indexOf(delimiter) + delimiter.length);
			heightString = heightString.substr(0, frameHtml.indexOf(" ") - 1);
			heightString = heightString.split("\"").join("").split("'").join("");
			return parseInt(heightString);
		}
	}, {
		key: 'render',
		value: function render() {

			var frameHtml = this.props.embedHtml;
			frameHtml = frameHtml.replace("<iframe", "<iframe class='facebookLiveStreamFrame'");

			var width = this.getTargetWidth(frameHtml);
			var height = this.getTargetHeight(frameHtml);
			var rate = width * 1.0 / height;
			var targetWidth = this.props.containerWidth;
			var targetHeight = parseInt(targetWidth / rate);

			return _react2.default.createElement(
				'div',
				null,
				this.props.description && this.props.description.length > 0 && _react2.default.createElement(
					'h1',
					null,
					this.props.description
				),
				_react2.default.createElement('div', { dangerouslySetInnerHTML: {
						__html: '\n\t\t\t\t\t<style>\n\t\t\t\t\t\t.facebookLiveStreamFrame{\n\t\t\t\t\t\t\twidth:' + targetWidth + 'px !important;\n\t\t\t\t\t\t\theight: ' + targetHeight + 'px !important;\n\t\t\t\t\t\t}\n\t\t\t\t\t</style>\n\t\t\t\t\t'
					} }),
				_react2.default.createElement('div', { dangerouslySetInnerHTML: { __html: frameHtml } })
			);
		}
	}]);

	return FacebookVideoStream;
}(_react2.default.PureComponent);

FacebookVideoStream.propTypes = {
	containerWidth: _propTypes2.default.number,
	embedHtml: _propTypes2.default.string,
	description: _propTypes2.default.string,
	id: _propTypes2.default.string
};
FacebookVideoStream.defaultProps = {
	description: '',
	id: ''
};
exports.default = (0, _reactDimensions2.default)()(FacebookVideoStream);