'use strict';

Object.defineProperty(exports, "__esModule", {
	value: true
});

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _reactBootstrap = require('react-bootstrap');

var _reactRouterDom = require('react-router-dom');

var _AlbumView = require('./AlbumView');

var _AlbumView2 = _interopRequireDefault(_AlbumView);

var _reactRouterBootstrap = require('react-router-bootstrap');

var _styles = require('@material-ui/core/styles');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var GalleryCollection = function (_React$Component) {
	_inherits(GalleryCollection, _React$Component);

	function GalleryCollection() {
		_classCallCheck(this, GalleryCollection);

		return _possibleConstructorReturn(this, (GalleryCollection.__proto__ || Object.getPrototypeOf(GalleryCollection)).apply(this, arguments));
	}

	_createClass(GalleryCollection, [{
		key: 'getStyles',
		value: function getStyles() {
			var styles = {
				albumThumbContainer: {
					width: 250,
					height: 300,
					marginLeft: 'auto',
					marginRight: 'auto',
					textAlign: 'right'
				},
				albumThumbImage: {
					width: '100%',
					height: 200,
					backgroundSize: 'cover',
					backgroundPosition: 'center'
				},
				albumThumbTitle: {
					fontSize: '1.2em',
					fontWeight: 'bold',
					color: this.props.theme.palette.accent1Color,
					borderTop: '2px solid ' + this.props.theme.palette.primary2Color,
					marginTop: 3
				},
				albumThumNumPics: {
					color: this.props.theme.palette.primary2Color
				}
			};
			return styles;
		}
	}, {
		key: 'render',
		value: function render() {
			var _this2 = this;

			var styles = this.getStyles();
			var that = this;

			return _react2.default.createElement(
				'div',
				null,
				_react2.default.createElement(
					_reactBootstrap.Row,
					null,
					_react2.default.createElement(_reactRouterDom.Route, { exact: true, path: '' + this.props.match.url, render: function render() {
							return _react2.default.createElement(
								'div',
								null,
								_this2.props.data.map(function (album, i) {
									return _react2.default.createElement(
										'div',
										{ key: i },
										_react2.default.createElement(
											_reactBootstrap.Col,
											{ xs: 12, sm: 6, md: 4, lg: 3, style: { paddingLeft: 2, paddingRight: 2 } },
											_react2.default.createElement(
												_reactRouterBootstrap.LinkContainer,
												{ to: (that.props.match.url + '/' + album.id).replace('//', '/') },
												_react2.default.createElement(
													_reactBootstrap.Thumbnail,
													{ style: styles.albumThumbContainer },
													_react2.default.createElement('div', { style: _extends({}, styles.albumThumbImage, { backgroundImage: 'url(' + album.media.media$content[0].url + ')' }) }),
													_react2.default.createElement(
														'p',
														{ style: styles.albumThumbTitle },
														album.title
													),
													_react2.default.createElement(
														'p',
														{ style: styles.albumThumNumPics },
														album.num_photos,
														' photo',
														album.num_photos > 1 && 's'
													)
												)
											)
										)
									);
								})
							);
						} }),
					_react2.default.createElement(_reactRouterDom.Route, { path: (this.props.match.url + '/:albumId').replace('//', '/'), render: function render(_ref) {
							var match = _ref.match;


							var selectedAlbum = null;
							console.log(_this2.props.data);
							for (var i = 0; i < _this2.props.data.length; i++) {
								if (_this2.props.data[i].id === match.params.albumId) {
									selectedAlbum = _this2.props.data[i];
									break;
								}
							}
							return _react2.default.createElement(_AlbumView2.default, { album: selectedAlbum });
						} })
				)
			);
		}
	}]);

	return GalleryCollection;
}(_react2.default.Component);

exports.default = (0, _styles.withTheme)()(GalleryCollection);