'use strict';

Object.defineProperty(exports, "__esModule", {
    value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var GradientScreen = function (_React$PureComponent) {
    _inherits(GradientScreen, _React$PureComponent);

    /*A shadow object looks like
    	{
    		length:number,
    		color:string
    	}
    */

    function GradientScreen(props) {
        _classCallCheck(this, GradientScreen);

        var _this = _possibleConstructorReturn(this, (GradientScreen.__proto__ || Object.getPrototypeOf(GradientScreen)).call(this, props));

        _this.state = {
            ready: false,
            id: 0
        };
        return _this;
    }

    _createClass(GradientScreen, [{
        key: 'componentWillMount',
        value: function componentWillMount() {
            this.setState({ id: 'id' + new Date().getTime() });
        }
    }, {
        key: 'componentDidMount',
        value: function componentDidMount() {
            this.setState({ ready: true });
        }
    }, {
        key: 'getTopShadow',
        value: function getTopShadow() {
            return this.getShadow(this.props.topShadow, function (length, blur, spread, color) {
                return 'inset 0px ' + length + 'px ' + blur + 'px ' + spread + 'px ' + color;
            });
        }
    }, {
        key: 'getBottomShadow',
        value: function getBottomShadow() {
            return this.getShadow(this.props.bottomShadow, function (length, blur, spread, color) {
                return 'inset 0px ' + -length + 'px ' + blur + 'px ' + spread + 'px ' + color;
            });
        }
    }, {
        key: 'getLeftShadow',
        value: function getLeftShadow() {
            return this.getShadow(this.props.leftShadow, function (length, blur, spread, color) {
                return 'inset ' + length + 'px 0px ' + blur + 'px ' + spread + 'px ' + color;
            });
        }
    }, {
        key: 'getRightShadow',
        value: function getRightShadow() {
            return this.getShadow(this.props.rightShadow, function (length, blur, spread, color) {
                return 'inset ' + -length + 'px 0px ' + blur + 'px ' + spread + 'px ' + color;
            });
        }
    }, {
        key: 'getShadow',
        value: function getShadow(shadow, formatF) {

            if (!shadow || shadow === null) return 'inset 0px 0px 0px rgba(0,0,0,0)';

            //no ngative values on the blur
            if (shadow.blur < 0) {
                shadow.blur *= -1;
            }

            var blur = Math.abs(shadow.length / 2);

            var spread = -blur;

            var shadow = formatF(shadow.length, blur, spread, shadow.color);

            return shadow;
        }
    }, {
        key: 'render',
        value: function render() {

            var s1 = this.getTopShadow() + ', ' + this.getBottomShadow();
            var s2 = this.getLeftShadow() + ', ' + this.getRightShadow();

            return _react2.default.createElement(
                'div',
                { style: { position: 'relative', width: '100%', height: '100%' } },
                this.state.ready && _react2.default.createElement('div', { dangerouslySetInnerHTML: {
                        __html: '\n                        <style>\n                            .kokolib_gradientScreen_shadow {\n                                content: "";\n                                height: 100%;\n                                left: 0;\n                                margin: 0 auto;\n                                pointer-events: none;\n                                position: absolute;\n                                right: 0;\n                                top: 0;\n                            }\n\n                            .kokolib_gradientScreen_shadow_one_' + this.state.id + ' {\n                                box-shadow: ' + s1 + '\n                            }\n\n                            .kokolib_gradientScreen_shadow_two_' + this.state.id + ' {\n                                box-shadow: ' + s2 + '\n                            }\n                        </style>\n                        '
                    } }),
                this.state.ready && _react2.default.createElement('div', { className: "kokolib_gradientScreen_shadow kokolib_gradientScreen_shadow_one_" + this.state.id }),
                _react2.default.createElement('div', { className: 'kokolib_shadowScreen_fog', style: {
                        content: "",
                        height: '100%',
                        left: 0,
                        margin: '0 auto',
                        pointerEvents: 'none',
                        position: 'absolute',
                        right: 0,
                        top: 0,
                        background: 'rgba(0,0,0,' + this.props.fogAmount + ')'
                    } }),
                this.state.ready && _react2.default.createElement('div', { className: "kokolib_gradientScreen_shadow kokolib_gradientScreen_shadow_two_" + this.state.id })
            );
        }
    }]);

    return GradientScreen;
}(_react2.default.PureComponent);

GradientScreen.propTypes = {
    topShadow: _propTypes2.default.object,
    bottomShadow: _propTypes2.default.object,
    leftShadow: _propTypes2.default.object,
    rightShadow: _propTypes2.default.object,
    fogAmount: _propTypes2.default.number
};
GradientScreen.defaultProps = {
    topShadow: null,
    bottomShadow: null,
    leftShadow: null,
    rightShadow: null,
    fogAmount: 0
};
exports.default = GradientScreen;