'use strict';

Object.defineProperty(exports, "__esModule", {
	value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _SocialMediaButtons = require('./SocialMediaButtons');

var _SocialMediaButtons2 = _interopRequireDefault(_SocialMediaButtons);

var _CryptoButtons = require('./CryptoButtons');

var _CryptoButtons2 = _interopRequireDefault(_CryptoButtons);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _styles = require('@material-ui/core/styles');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var MainFooter = function (_React$PureComponent) {
	_inherits(MainFooter, _React$PureComponent);

	function MainFooter() {
		_classCallCheck(this, MainFooter);

		return _possibleConstructorReturn(this, (MainFooter.__proto__ || Object.getPrototypeOf(MainFooter)).apply(this, arguments));
	}

	_createClass(MainFooter, [{
		key: 'getStyles',
		value: function getStyles() {

			var palette = this.props.theme.palette;

			var styles = {
				footer: {
					backgroundColor: this.props.transparent ? 'transparent' : palette.footerBackgroundColor || palette.primary1Color,
					position: "relative",
					overflow: "hidden",
					padding: '4em 0 4em 0',
					color: palette.textColor
				},
				footerBefore: {
					content: "",
					height: "100%",
					left: 0,
					margin: "0 auto",
					pointerEvents: "none",
					position: "absolute",
					right: 0,
					top: 0,
					zIndex: 1
				},
				contact: {
					textAlign: 'center'
				},
				copyRight: {
					textAlign: 'center',
					color: palette.footerCopyrightColor || palette.primary2Color,
					fontSize: '0.9em',
					cursor: 'default'
				}
			};
			return styles;
		}
	}, {
		key: 'render',
		value: function render() {

			var styles = this.getStyles();

			return _react2.default.createElement(
				'div',
				{ style: styles.footer },
				_react2.default.createElement('div', { style: styles.footerBefore }),
				_react2.default.createElement(
					'div',
					{ className: 'contact', style: styles.contact },
					_react2.default.createElement(_SocialMediaButtons2.default, this.props),
					this.props.cryptoLinks && this.props.cryptoLinks.length > 0 && _react2.default.createElement(_CryptoButtons2.default, this.props),
					_react2.default.createElement(
						'div',
						{ className: 'copyright', style: styles.copyRight },
						_react2.default.createElement(
							'ul',
							{ className: 'menu', style: { padding: 0 } },
							_react2.default.createElement(
								'li',
								{ style: { listStyle: "none" } },
								'\xA9 ',
								this.props.orgName,
								'. All rights reserved.'
							)
						)
					)
				)
			);
		}
	}]);

	return MainFooter;
}(_react2.default.PureComponent);

MainFooter.propTypes = {
	buttons: _propTypes2.default.array,
	cryptoLinks: _propTypes2.default.array,
	orgName: _propTypes2.default.string,
	transparent: _propTypes2.default.bool
};
MainFooter.defaultProps = {
	buttons: [],
	cryptoLinks: [],
	orgName: "Your Organization",
	transparent: false
};
exports.default = (0, _styles.withTheme)()(MainFooter);