'use strict';

Object.defineProperty(exports, "__esModule", {
	value: true
});

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _reactWaypoint = require('react-waypoint');

var _reactWaypoint2 = _interopRequireDefault(_reactWaypoint);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _reactBootstrap = require('react-bootstrap');

var _reactRouterBootstrap = require('react-router-bootstrap');

var _reactDimensions = require('react-dimensions');

var _reactDimensions2 = _interopRequireDefault(_reactDimensions);

var _styles = require('@material-ui/core/styles');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var PrimaryNavBarCSS = function (_React$PureComponent) {
	_inherits(PrimaryNavBarCSS, _React$PureComponent);

	function PrimaryNavBarCSS() {
		_classCallCheck(this, PrimaryNavBarCSS);

		return _possibleConstructorReturn(this, (PrimaryNavBarCSS.__proto__ || Object.getPrototypeOf(PrimaryNavBarCSS)).apply(this, arguments));
	}

	_createClass(PrimaryNavBarCSS, [{
		key: 'render',
		value: function render() {

			var textColor = this.props.palette.navBarTextColor || this.props.palette.textColor;
			var selectedTextColor = this.props.palette.navBarSelectedTextColor || this.props.palette.accent1Color;
			var hoverTextColor = this.props.palette.navBarHoverTextColor || this.props.palette.accent2Color;

			var backgroundColor = this.props.palette.navBarBackgroundColor || this.props.palette.primary1Color;
			var hoverBackgroundColor = this.props.palette.navBarHoverBackgroundColor || this.props.palette.primary3Color;
			var selectedBackgroundColor = this.props.palette.navBarSelectedBackgroundColor || this.props.palette.primary2Color;

			var decorationColor = this.props.palette.navBarDecorationColor || this.props.palette.accent1Color;

			var font = this.props.theme.headerFontFamily ? this.props.theme.headerFontFamily : this.props.theme.fontFamily;

			return _react2.default.createElement('div', { dangerouslySetInnerHTML: {
					__html: '\n\t\t\t\t<style>\n\t\t\t\t\t@keyframes navbaranimation {\n\t\t\t\t\t    from {\n\t\t\t\t\t    \tbackground-color: transparent;\n\t\t\t\t\t    }\n\t\t\t\t\t    to {\n\t\t\t\t\t    \tbackground-color: ' + backgroundColor + ';\n\t\t\t\t\t    }\n\t\t\t\t\t}\n\n\t\t\t\t\t@keyframes navbaranimationreverse {\n\t\t\t\t\t    from {\n\t\t\t\t\t    \tbackground-color: ' + backgroundColor + ';\n\t\t\t\t\t    }\n\t\t\t\t\t    to {\n\t\t\t\t\t    \tbackground-color: transparent;\n\t\t\t\t\t    }\n\t\t\t\t\t}\n\n\t\t\t\t\t@media (max-width: 767px) {\n\t\t\t\t\t\t.navbar-inverse .navbar-nav .open .dropdown-menu>li>a {\n\t\t\t\t\t\t\tcolor:#fff;\n\t\t\t\t\t\t}\n\t\t\t\t\t\t.navbar-inverse .navbar-nav .open .dropdown-menu>li>a:hover,\n\t\t\t\t\t\t.navbar-inverse .navbar-nav .open .dropdown-menu>.active>a:hover {\n\t\t\t\t\t\t\tcolor:' + hoverTextColor + ' !important;\n\t\t\t\t\t    \tbackground-color: ' + hoverBackgroundColor + ';\n\t\t\t\t\t\t}\n\n\t\t\t\t\t\t.navbar-inverse .navbar-nav .open .dropdown-menu>.active>a{\n\t\t\t\t\t    \tbackground-color: ' + selectedBackgroundColor + ';\n\t\t\t\t\t\t}\n\t\t\t\t\t}\n\n\t\t\t\t\t.navbar-inverse .navbar-nav>.open>a,\n\t\t\t\t\t.navbar-inverse .navbar-nav>.open>a:focus,\n\t\t\t\t\t.navbar-inverse .navbar-nav>.open>a:hover,\n\t\t\t\t\t.navbar-inverse .navbar-nav>.active>a,\n\t\t\t\t\t.navbar-inverse .navbar-nav>.active>a:focus,\n\t\t\t\t\t.navbar-inverse .navbar-nav>.active>a:hover\n\t\t\t\t\t{\n\t\t\t\t\t\tbackground-color: ' + selectedBackgroundColor + ' !important;\n\t\t\t\t\t}\n\n\t\t\t\t\t.kokolib_navbarcontainer .dropdown-menu\n\t\t\t\t\t{\n\t\t\t\t\t    background-color: ' + backgroundColor + ';\n\t\t\t\t\t}\n\n\t\t\t\t\t.kokolib_navbarcontainer .dropdown-menu>li>a\n\t\t\t\t\t{\n\t\t\t\t\t    color: #fff;\n\t\t\t\t\t}\n\n\t\t\t\t\t.kokolib_navbarcontainer .dropdown-menu>li>a:focus,\n\t\t\t\t\t.kokolib_navbarcontainer .dropdown-menu>li>a:hover\n\t\t\t\t\t{\n\t\t\t\t\t\tcolor: ' + hoverTextColor + ';\n\t\t\t\t\t    background-color: ' + hoverBackgroundColor + ';\n\t\t\t\t\t}\n\t\t\t\t\t.kokolib_navbarcontainer .dropdown-menu>.active>a,\n\t\t\t\t\t.kokolib_navbarcontainer .dropdown-menu>.active>a:focus,\n\t\t\t\t\t.kokolib_navbarcontainer .dropdown-menu>.active>a:hover {\n\n\t\t\t\t\t\tcolor: ' + selectedTextColor + ';\n\t\t\t\t\t    background-color: ' + selectedBackgroundColor + ';\n\t\t\t\t\t}\n\n\t\t\t\t\t.navbar\n\t\t\t\t\t{\n\t\t\t\t\t\tfont-family: ' + font + '\n\t\t\t\t\t}\n\n\t\t\t\t\t.mainNavBarInvisible {\n\t\t\t\t\t\tbackground-color: transparent;\n\t\t\t\t\t\tanimation-name: navbaranimationreverse;\n\t\t\t\t\t    animation-duration: 0.5s;\n\t\t\t\t\t}\n\n\t\t\t\t\t.mainNavBar {\n\t\t\t\t\t    background-color: ' + backgroundColor + ';\n\t\t\t\t\t\tanimation-name: navbaranimation;\n\t\t\t\t\t    animation-duration: 0.5s;\n\t\t\t\t\t}\n\n\t\t\t\t\t.mainNavBarFullVisible {\n\t\t\t\t\t\t-webkit-box-shadow: inset 0 -45px 100px -30px ' + this.props.palette.accent1Color + ';\n\t\t\t\t\t}\n\n\t\t\t\t\t.navbar-nav {\n\t\t\t\t\t\tmargin: 0px -15px;\n\t\t\t\t\t}\n\t\t\t\t\t.navbar-nav>li>a {\n\t\t\t\t\t\tcolor:' + textColor + ' !important;\n\t\t\t\t\t    border-bottom: 3px transparent solid;\n\t\t\t\t\t}\n\t\t\t\t\t.nav .open>a,\n\t\t\t\t\t.nav .open>a:focus,\n\t\t\t\t\t.nav .open>a:hover {\n\t\t\t\t\t    border-bottom: 3px ' + decorationColor + ' solid;\n\t\t\t\t\t}\n\n\t\t\t\t\t.navbar-inverse .navbar-nav>.active>a,\n\t\t\t\t\t.navbar-nav>li>a:hover\n\t\t\t\t\t{\n\t\t\t\t\t    border-bottom: 3px ' + decorationColor + ' solid;\n\t\t\t\t\t    color: ' + selectedTextColor + ' !important;\n\t\t\t\t\t}\n\n\t\t\t\t\t.navbar-inverse .navbar-toggle {\n\t\t\t\t\t\tborder: none;\n    \t\t\t\t\tmargin-right: 40px;\n\t\t\t\t\t}\n\n\t\t\t\t\t.navbar-inverse .navbar-toggle:focus,\n\t\t\t\t\t.navbar-inverse .navbar-toggle:hover\n\t\t\t\t\t{\n\t\t\t\t\t    background-color: ' + hoverBackgroundColor + ';\n\t\t\t\t\t}\n\n\t\t\t\t\t.navbar-default .navbar-toggle {\n\t\t\t\t\t\tborder: 0;\n\t\t\t\t\t}\n\n\n\t\t\t\t</style>\n\t\t\t\t'
				} });
		}
	}]);

	return PrimaryNavBarCSS;
}(_react2.default.PureComponent);

var NavigationGroup = function (_React$PureComponent2) {
	_inherits(NavigationGroup, _React$PureComponent2);

	function NavigationGroup() {
		_classCallCheck(this, NavigationGroup);

		return _possibleConstructorReturn(this, (NavigationGroup.__proto__ || Object.getPrototypeOf(NavigationGroup)).apply(this, arguments));
	}

	_createClass(NavigationGroup, [{
		key: 'render',
		value: function render() {
			return _react2.default.createElement(
				_reactBootstrap.NavDropdown,
				{ eventKey: this.props.index,
					title: this.props.title,
					id: "navigation-group-dropdown-" + this.props.index },
				this.props.children.map(function (link, i) {
					if (link.children && link.children != null && link.children.length > 0) {
						return _react2.default.createElement(NavigationGroup, _extends({}, link, { key: i, index: i }));
					}
					return _react2.default.createElement(
						_reactRouterBootstrap.IndexLinkContainer,
						{ to: link.link, key: i },
						_react2.default.createElement(
							_reactBootstrap.NavItem,
							{ eventKey: i + i / 10 },
							link.title
						)
					);
				})
			);
		}
	}]);

	return NavigationGroup;
}(_react2.default.PureComponent);

NavigationGroup.propTypes = {
	title: _propTypes2.default.string,
	index: _propTypes2.default.number,
	children: _propTypes2.default.array
};
NavigationGroup.defaultProps = {
	title: "",
	index: 0,
	children: []
};

var PrimaryNavBar = function (_React$PureComponent3) {
	_inherits(PrimaryNavBar, _React$PureComponent3);

	function PrimaryNavBar(props) {
		var _this3$state;

		_classCallCheck(this, PrimaryNavBar);

		var _this3 = _possibleConstructorReturn(this, (PrimaryNavBar.__proto__ || Object.getPrototypeOf(PrimaryNavBar)).call(this, props));

		_this3.handleWaypointOnPositionChange = function (_ref) {
			var previousPosition = _ref.previousPosition,
			    currentPosition = _ref.currentPosition;

			_this3.setState({
				navbarBrandVisible: _this3.props.alwaysOpaque || currentPosition === 'above'
			});
			currentPosition === 'above' && _this3.setState({
				navBarStyleChanged: true
			});
		};

		_this3.state = (_this3$state = {
			navbarBrandVisible: false,
			navBarStyleChanged: false,
			navbarExpanded: false
		}, _defineProperty(_this3$state, 'navbarExpanded', false), _defineProperty(_this3$state, 'containerWidth', 0), _this3$state);
		return _this3;
	}

	_createClass(PrimaryNavBar, [{
		key: 'getStyles',
		value: function getStyles() {
			var styles = {
				navBar: {
					border: 0
				},
				navBarLogoImageContainer: {
					height: 53,
					padding: 0
				},
				navBarLogoImage: {
					height: '100%'
				}
			};
			return styles;
		}
	}, {
		key: 'getNavBarStyle',
		value: function getNavBarStyle() {

			//always visible on small screens
			if (this.props.containerWidth < 768) return "mainNavBar";

			//always starts to false so if this is true we have a change
			if (this.state.navbarBrandVisible) return "mainNavBar";

			//however the corellary is not true so we have to check
			if (this.state.navBarStyleChanged || this.props.containerWidth >= 768) return "mainNavBarInvisible";

			return "";
		}
	}, {
		key: 'render',
		value: function render() {

			var styles = this.getStyles();

			var smallScreen = this.props.containerWidth < 768;
			var largeScreen = this.props.containerWidth >= 1200;
			var mediumScreen = !smallScreen && !largeScreen;

			var that = this;

			return _react2.default.createElement(
				'div',
				{ className: 'kokolib_navbarcontainer' },
				_react2.default.createElement(PrimaryNavBarCSS, { palette: this.props.theme.palette, theme: this.props.theme }),
				_react2.default.createElement(
					_reactBootstrap.Navbar,
					{ collapseOnSelect: true,
						inverse: this.props.inverse,
						staticTop: this.props.staticTop,
						fixedTop: this.props.fixedTop,
						fluid: this.props.fluid,
						style: styles.navBar,
						className: this.getNavBarStyle() },
					_react2.default.createElement(
						_reactBootstrap.Navbar.Header,
						null,
						this.state.navbarBrandVisible && _react2.default.createElement(
							_reactBootstrap.Navbar.Brand,
							null,
							_react2.default.createElement(
								'a',
								{ href: '/', style: styles.navBarLogoImageContainer },
								_react2.default.createElement(_reactBootstrap.Image, { src: this.props.logoImagePath, responsive: true, style: styles.navBarLogoImage })
							)
						),
						_react2.default.createElement(_reactBootstrap.Navbar.Toggle, null)
					),
					_react2.default.createElement(
						_reactBootstrap.Navbar.Collapse,
						null,
						_react2.default.createElement(
							_reactBootstrap.Nav,
							{ pullRight: this.props.rightNavigation },
							this.props.navigationScheme.map(function (link, i) {

								if (link.mdHidden && mediumScreen) return;
								if (link.lgHidden && largeScreen) return;
								if (link.smHidden && smallScreen) return;

								if (link.children && link.children != null && link.children.length > 0) {
									return _react2.default.createElement(NavigationGroup, _extends({}, link, { key: i, index: i + 1 }));
								}
								return _react2.default.createElement(
									_reactRouterBootstrap.IndexLinkContainer,
									{ to: link.link, key: i },
									_react2.default.createElement(
										_reactBootstrap.NavItem,
										{ eventKey: i + 1 },
										link.title
									)
								);
							})
						)
					)
				),
				_react2.default.createElement(_reactWaypoint2.default, { topOffset: this.props.visibilityToggleOffset * -1,
					onPositionChange: this.handleWaypointOnPositionChange })
			);
		}
	}]);

	return PrimaryNavBar;
}(_react2.default.PureComponent);

PrimaryNavBar.propTypes = {
	logoImagePath: _propTypes2.default.string,
	visibilityToggleOffset: _propTypes2.default.number,
	navigationScheme: _propTypes2.default.array,
	alwaysOpaque: _propTypes2.default.bool,
	inverse: _propTypes2.default.bool,
	rightNavigation: _propTypes2.default.bool,
	staticTop: _propTypes2.default.bool,
	fixedTop: _propTypes2.default.bool,
	fluid: _propTypes2.default.bool
};
PrimaryNavBar.defaultProps = {
	logoImagePath: "",
	visibilityToggleOffset: 0,
	navigationScheme: [],
	alwaysOpaque: false,
	inverse: false,
	rightNavigation: true,
	staticTop: true,
	fixedTop: true,
	fluid: true
};
exports.default = (0, _styles.withTheme)()((0, _reactDimensions2.default)()(PrimaryNavBar));