'use strict';

Object.defineProperty(exports, "__esModule", {
	value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _Paper = require('@material-ui/core/Paper');

var _Paper2 = _interopRequireDefault(_Paper);

var _reactBootstrap = require('react-bootstrap');

var _reactRouterBootstrap = require('react-router-bootstrap');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var ResourceLinkCSS = function (_React$PureComponent) {
	_inherits(ResourceLinkCSS, _React$PureComponent);

	function ResourceLinkCSS() {
		_classCallCheck(this, ResourceLinkCSS);

		return _possibleConstructorReturn(this, (ResourceLinkCSS.__proto__ || Object.getPrototypeOf(ResourceLinkCSS)).apply(this, arguments));
	}

	_createClass(ResourceLinkCSS, [{
		key: 'render',
		value: function render() {

			return _react2.default.createElement('div', { dangerouslySetInnerHTML: {
					__html: '\n\t\t\t\t<style>\n\t\t\t\t\t.kokolib_resource_link {\n\t\t\t\t\t\t-webkit-transition: 1s;\n\t\t\t\t\t\t-moz-transition: 1s;\n\t\t\t\t\t\t-o-transition: 1s;\n\t\t\t\t\t\ttransition: 1s;\n\t\t\t\t\t}\n\n\t\t\t\t\t.kokolib_resource_link.focused {\n\t\t\t\t\t\ttransform:scale(1.03) !important;\n\t\t\t\t\t}\n\n\t\t\t\t</style>\n\t\t\t\t'
				} });
		}
	}]);

	return ResourceLinkCSS;
}(_react2.default.PureComponent);

var ResourceLink = function (_React$PureComponent2) {
	_inherits(ResourceLink, _React$PureComponent2);

	function ResourceLink(props) {
		_classCallCheck(this, ResourceLink);

		var _this2 = _possibleConstructorReturn(this, (ResourceLink.__proto__ || Object.getPrototypeOf(ResourceLink)).call(this, props));

		_this2.onHoverEnter = function () {
			_this2.setState({
				focused: true
			});
		};

		_this2.onHoverLeave = function () {
			_this2.setState({
				focused: false
			});
		};

		_this2.state = {
			focused: false
		};
		return _this2;
	}

	_createClass(ResourceLink, [{
		key: 'getStyles',
		value: function getStyles() {
			var styles = {
				anchor: {
					textDecoration: 'none'
				},
				paper: {
					padding: 0,
					marginLeft: 'auto',
					marginRight: 'auto',
					textDecoration: 'none'
				},
				container: {
					width: '100%',
					minHeight: 300,
					textAlign: 'left',
					padding: 0,
					margin: 0,
					textDecoration: 'none'
				},
				image: {
					width: '100%',
					height: 200,
					backgroundSize: 'contain',
					backgroundPosition: 'center',
					backgroundRepeat: 'no-repeat',
					backgroundImage: 'url(' + this.props.image + ')'
				},
				title: {
					fontSize: '1.2em',
					fontWeight: 'bold',
					marginTop: 3,
					textDecoration: 'none'
				},
				description: {
					textDecoration: 'none'
				}
			};
			return styles;
		}
	}, {
		key: 'render',
		value: function render() {

			var styles = this.getStyles();

			var componentClasses = ['kokolib_resource_link'];
			if (this.state.focused) {
				componentClasses.push('focused');
			}

			return _react2.default.createElement(
				'div',
				null,
				_react2.default.createElement(ResourceLinkCSS, null),
				_react2.default.createElement(
					'a',
					{ href: this.props.link, target: '_blank', style: styles.anchor },
					_react2.default.createElement(
						'div',
						{ className: componentClasses.join(' '),
							onMouseEnter: this.onHoverEnter,
							onMouseLeave: this.onHoverLeave },
						_react2.default.createElement(
							_Paper2.default,
							{ zDepth: 3, style: styles.paper },
							_react2.default.createElement(
								_reactBootstrap.Thumbnail,
								{ style: styles.container },
								_react2.default.createElement('div', { style: styles.image }),
								_react2.default.createElement(
									'p',
									{ style: styles.title },
									this.props.title
								),
								_react2.default.createElement(
									'p',
									{ style: styles.description },
									this.props.description
								)
							)
						)
					)
				)
			);
		}
	}]);

	return ResourceLink;
}(_react2.default.PureComponent);

exports.default = ResourceLink;