'use strict';

Object.defineProperty(exports, "__esModule", {
    value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var ShadowScreen = function (_React$PureComponent) {
    _inherits(ShadowScreen, _React$PureComponent);

    /*A shadow object looks like
    	{
    		v:number,
    		h:number,
    		blur:number,
    		spread:number,
    		color:string
    	}
    
    */
    function ShadowScreen(props) {
        _classCallCheck(this, ShadowScreen);

        var _this = _possibleConstructorReturn(this, (ShadowScreen.__proto__ || Object.getPrototypeOf(ShadowScreen)).call(this, props));

        _this.state = {
            ready: false,
            id: 0
        };
        return _this;
    }

    _createClass(ShadowScreen, [{
        key: 'componentWillMount',
        value: function componentWillMount() {
            this.setState({ id: 'id' + new Date().getTime() });
        }
    }, {
        key: 'componentDidMount',
        value: function componentDidMount() {
            this.setState({ ready: true });
        }
    }, {
        key: 'getShadowOne',
        value: function getShadowOne() {
            return this.getShadow(this.props.shadowOne);
        }
    }, {
        key: 'getShadowTwo',
        value: function getShadowTwo() {
            return this.getShadow(this.props.shadowTwo);
        }
    }, {
        key: 'getShadowThree',
        value: function getShadowThree() {
            return this.getShadow(this.props.shadowThree);
        }
    }, {
        key: 'getShadowFour',
        value: function getShadowFour() {
            return this.getShadow(this.props.shadowFour);
        }
    }, {
        key: 'getShadow',
        value: function getShadow(shadow) {

            if (!shadow || shadow === null) return 'inset 0px 0px 0px rgba(0,0,0,0)';

            var shadow = 'inset ' + shadow.h + 'px ' + shadow.v + 'px ' + Math.abs(shadow.blur) + 'px ' + shadow.spread + 'px ' + shadow.color;

            return shadow;
        }
    }, {
        key: 'render',
        value: function render() {

            var s1 = this.getShadowOne() + ', ' + this.getShadowTwo();
            var s2 = this.getShadowThree() + ', ' + this.getShadowFour();

            return _react2.default.createElement(
                'div',
                { style: { position: 'relative', width: '100%', height: '100%' } },
                this.state.ready && _react2.default.createElement('div', { dangerouslySetInnerHTML: {
                        __html: '\n                        <style>\n                            .kokolib_shadowScreen_shadow {\n                                content: "";\n                                height: 100%;\n                                left: 0;\n                                margin: 0 auto;\n                                pointer-events: none;\n                                position: absolute;\n                                right: 0;\n                                top: 0;\n                            }\n\n                            .kokolib_shadowScreen_shadow_one_' + this.state.id + ' {\n                                box-shadow: ' + s1 + '\n                            }\n\n                            .kokolib_shadowScreen_shadow_two_' + this.state.id + ' {\n                                box-shadow: ' + s2 + '\n                            }\n                        </style>\n                        '
                    } }),
                this.state.ready && _react2.default.createElement('div', { className: "kokolib_shadowScreen_shadow kokolib_shadowScreen_shadow_one_" + this.state.id }),
                _react2.default.createElement('div', { className: 'kokolib_shadowScreen_fog', style: {
                        content: "",
                        height: '100%',
                        left: 0,
                        margin: '0 auto',
                        pointerEvents: 'none',
                        position: 'absolute',
                        right: 0,
                        top: 0,
                        background: 'rgba(0,0,0,' + this.props.fogAmount
                    } }),
                this.state.ready && _react2.default.createElement('div', { className: "kokolib_shadowScreen_shadow kokolib_shadowScreen_shadow_two_" + this.state.id })
            );
        }
    }]);

    return ShadowScreen;
}(_react2.default.PureComponent);

ShadowScreen.propTypes = {
    shadowOne: _propTypes2.default.object,
    shadowTwo: _propTypes2.default.object,
    shadowThree: _propTypes2.default.object,
    shadowFour: _propTypes2.default.object,
    fogAmount: _propTypes2.default.number
};
ShadowScreen.defaultProps = {
    shadowOne: null,
    shadowTwo: null,
    shadowThree: null,
    shadowFour: null,
    fogAmount: 0
};
exports.default = ShadowScreen;