'use strict';

Object.defineProperty(exports, "__esModule", {
	value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _reactBootstrap = require('react-bootstrap');

var _Spacer = require('./Spacer');

var _Spacer2 = _interopRequireDefault(_Spacer);

var _DataContainer = require('./DataContainer');

var _DataContainer2 = _interopRequireDefault(_DataContainer);

var _UrlThumb = require('./UrlThumb');

var _UrlThumb2 = _interopRequireDefault(_UrlThumb);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var UrlResourceList = function (_React$Component) {
	_inherits(UrlResourceList, _React$Component);

	function UrlResourceList() {
		_classCallCheck(this, UrlResourceList);

		return _possibleConstructorReturn(this, (UrlResourceList.__proto__ || Object.getPrototypeOf(UrlResourceList)).apply(this, arguments));
	}

	_createClass(UrlResourceList, [{
		key: 'render',
		value: function render() {

			return _react2.default.createElement(_DataContainer2.default, { action: this.props.action, resultRender: function resultRender(data) {
					return _react2.default.createElement(
						'div',
						null,
						data && data.map(function (resource, i) {
							if (!resource || Object.keys(resource).length <= 0) return _react2.default.createElement('span', { key: i });

							if (!resource.url || resource.url.length <= 0 || resource.url.endsWith(".pdf")) {
								return _react2.default.createElement(
									'div',
									{ key: i },
									_react2.default.createElement(_UrlThumb2.default, { url: resource.url,
										title: resource.title,
										description: resource.description,
										image: resource.image }),
									_react2.default.createElement(_Spacer2.default, { space: 25 })
								);
							}

							return _react2.default.createElement(_DataContainer2.default, { key: i,
								action: 'api/v1/GetPageMeta',
								parameters: [{ id: "url", value: resource.url }],
								showRawData: false,
								resultRender: function resultRender(pageData) {

									if (!pageData || Object.keys(pageData).length <= 0) {
										if (!resource || !resource.title && !resource.description) return _react2.default.createElement('span', null);else return _react2.default.createElement(
											'div',
											null,
											_react2.default.createElement(_UrlThumb2.default, { url: resource.url,
												title: resource.title,
												description: resource.description,
												image: resource.image }),
											_react2.default.createElement(_Spacer2.default, { space: 25 })
										);
									}

									return _react2.default.createElement(
										'div',
										null,
										_react2.default.createElement(_UrlThumb2.default, { url: pageData.url || resource.url,
											title: resource.title || pageData.title,
											description: resource.description || pageData.description,
											image: resource.image || pageData.image }),
										_react2.default.createElement(_Spacer2.default, { space: 25 })
									);
								},
								errorRender: function errorRender(error) {
									return _react2.default.createElement(
										'div',
										null,
										_react2.default.createElement(_UrlThumb2.default, { url: resource.url,
											title: resource.title,
											description: resource.description,
											image: resource.image }),
										_react2.default.createElement(_Spacer2.default, { space: 25 })
									);
								}
							});
						})
					);
				} });
		}
	}]);

	return UrlResourceList;
}(_react2.default.Component);

exports.default = UrlResourceList;