'use strict';

Object.defineProperty(exports, "__esModule", {
	value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _Paper = require('@material-ui/core/Paper');

var _Paper2 = _interopRequireDefault(_Paper);

var _reactBootstrap = require('react-bootstrap');

var _dateformat = require('dateformat');

var _dateformat2 = _interopRequireDefault(_dateformat);

var _Spacer = require('./Spacer');

var _Spacer2 = _interopRequireDefault(_Spacer);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var UrlThumbCss = function (_React$PureComponent) {
	_inherits(UrlThumbCss, _React$PureComponent);

	function UrlThumbCss() {
		_classCallCheck(this, UrlThumbCss);

		return _possibleConstructorReturn(this, (UrlThumbCss.__proto__ || Object.getPrototypeOf(UrlThumbCss)).apply(this, arguments));
	}

	_createClass(UrlThumbCss, [{
		key: 'render',
		value: function render() {

			return _react2.default.createElement('div', { dangerouslySetInnerHTML: {
					__html: '\n\t\t\t\t<style>\n\t\t\t\t\t.kokolib_url_thumb {\n\t\t\t\t\t\t-webkit-transition: 1s;\n\t\t\t\t\t\t-moz-transition: 1s;\n\t\t\t\t\t\t-o-transition: 1s;\n\t\t\t\t\t\ttransition: 1s;\n\t\t\t\t\t}\n\n\t\t\t\t\t.kokolib_url_thumb.focused {\n\t\t\t\t\t\ttransform:scale(1.03) !important;\n\t\t\t\t\t}\n\n\t\t\t\t</style>\n\t\t\t\t'
				} });
		}
	}]);

	return UrlThumbCss;
}(_react2.default.PureComponent);

var UrlThumb = function (_React$Component) {
	_inherits(UrlThumb, _React$Component);

	function UrlThumb(props) {
		_classCallCheck(this, UrlThumb);

		var _this2 = _possibleConstructorReturn(this, (UrlThumb.__proto__ || Object.getPrototypeOf(UrlThumb)).call(this, props));

		_this2.onHoverEnter = function () {
			_this2.setState({
				focused: true
			});
		};

		_this2.onHoverLeave = function () {
			_this2.setState({
				focused: false
			});
		};

		_this2.state = {
			focused: false
		};
		return _this2;
	}

	_createClass(UrlThumb, [{
		key: 'getStyles',
		value: function getStyles() {
			var styles = {
				paperStyle: {
					margin: 0,
					padding: 15
				},
				contentContainer: {},
				image: {
					width: '100%'
				}
			};
			return styles;
		}
	}, {
		key: 'getFirstImageFromContent',
		value: function getFirstImageFromContent(content) {
			return _react2.default.createElement(_reactBootstrap.Image, null);
		}
	}, {
		key: 'stripFirstImageFromContent',
		value: function stripFirstImageFromContent(content) {
			return content;
		}
	}, {
		key: 'renderContent',
		value: function renderContent() {

			var styles = this.getStyles();

			var hasImage = this.props.image && this.props.image.length > 0;

			return _react2.default.createElement(
				_reactBootstrap.Row,
				null,
				hasImage && _react2.default.createElement(
					_reactBootstrap.Col,
					{ xs: 12, sm: 5, md: 4, lg: 4 },
					_react2.default.createElement(_reactBootstrap.Image, { src: this.props.image, style: styles.image, className: 'kokolib_url_thumb_image' })
				),
				_react2.default.createElement(
					_reactBootstrap.Col,
					{ xs: 12,
						sm: hasImage ? 7 : 12,
						md: hasImage ? 8 : 12,
						lg: hasImage ? 8 : 12 },
					_react2.default.createElement(
						'div',
						{ className: 'kokolib_url_thumb_container' },
						_react2.default.createElement(
							'h2',
							{ className: 'kokolib_url_thumb_title' },
							' ',
							this.props.title
						),
						_react2.default.createElement(
							'div',
							{ style: styles.contentContainer, className: 'kokolib_url_thumb_description' },
							this.props.description
						)
					)
				)
			);
		}
	}, {
		key: 'render',
		value: function render() {

			var styles = this.getStyles();

			var hasImage = this.props.image && this.props.image.length > 0;

			var componentClasses = ['kokolib_url_thumb'];
			if (this.state.focused) {
				componentClasses.push('focused');
			}

			if (this.props.url && this.props.url.length > 0) return _react2.default.createElement(
				'div',
				null,
				_react2.default.createElement(UrlThumbCss, null),
				_react2.default.createElement(
					'a',
					{ href: this.props.url, target: '_blank' },
					_react2.default.createElement(
						'div',
						{ className: componentClasses.join(' '),
							onMouseEnter: this.onHoverEnter,
							onMouseLeave: this.onHoverLeave },
						_react2.default.createElement(
							_Paper2.default,
							{ style: styles.paperStyle, zDepth: 3 },
							this.renderContent()
						)
					)
				)
			);else return _react2.default.createElement(
				'div',
				null,
				this.renderContent()
			);
		}
	}]);

	return UrlThumb;
}(_react2.default.Component);

UrlThumb.propTypes = {
	url: _propTypes2.default.string,
	title: _propTypes2.default.string,
	image: _propTypes2.default.string,
	description: _propTypes2.default.string,
	targetPageRoot: _propTypes2.default.string
};
UrlThumb.defaultProps = {
	url: "",
	title: "",
	image: "",
	description: "",
	targetPageRoot: ""
};
exports.default = UrlThumb;