'use strict';

Object.defineProperty(exports, "__esModule", {
	value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _redux = require('redux');

var _reactRedux = require('react-redux');

var _kokolib = require('kokolib');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var DreamBlogArchive = function (_Component) {
	_inherits(DreamBlogArchive, _Component);

	function DreamBlogArchive() {
		var _ref;

		_classCallCheck(this, DreamBlogArchive);

		for (var _len = arguments.length, args = Array(_len), _key = 0; _key < _len; _key++) {
			args[_key] = arguments[_key];
		}

		var _this = _possibleConstructorReturn(this, (_ref = DreamBlogArchive.__proto__ || Object.getPrototypeOf(DreamBlogArchive)).call.apply(_ref, [this].concat(args)));

		_this.getOlderPosts = function () {
			_this.setState({ gettingOlder: true });
		};

		_this.state = {
			gettingOlder: false
		};
		return _this;
	}

	_createClass(DreamBlogArchive, [{
		key: 'componentWillMount',
		value: function componentWillMount() {

			//we got existing data, use that
			if (this.props.data && this.props.data.length > 0) {
				if (this.props.activePostId && this.props.activePostId.length > 0) {
					for (var i = 0; i < this.props.data.length; i++) {
						if (this.props.data[i].id === this.props.activePostId) {
							this.props.onSelectPost(this.props.data[i]);
							break;
						}
					}
				}
			} else {
				//try to get data from the server
				var dc = new _kokolib.DataContainer();
				var that = this;
				dc.GET("api/v1/GetBlog", null, function (data) {
					if (data && data != null && data.items && data.items != null && data.items.length > 0) {

						that.props.onUpdateArchive(data.items);
						that.props.onNextPageTokenUpdate(data.nextPageToken);

						if (that.props.activePostId && that.props.activePostId.length > 0) {

							for (var i = 0; i < data.items.length; i++) {
								if (data.items[i].id === that.props.activePostId) {
									that.props.onSelectPost(data.items[i]);
									break;
								}
							}
						} else {
							that.props.onSelectPost(data.items[0]);
						}
					}
				}, function (error) {
					console.log(error);
				});
			}
		}
	}, {
		key: 'render',
		value: function render() {
			var that = this;
			return _react2.default.createElement(
				'div',
				null,
				_react2.default.createElement(_kokolib.BlogArchive, { data: this.props.data, nextPageToken: this.props.nextPageToken, onGetOlderPosts: this.props.getOlderPosts, onSelectPost: function onSelectPost(post) {
						window.history.pushState(that.props.location.state, post.title, that.props.targetPageRoot + '/' + post.id);
						that.props.onSelectPost(post);
					} }),
				this.state.gettingOlder && _react2.default.createElement(_kokolib.DataContainer, { action: '/api/v1/GetBlog',
					parameters: [{ id: "pageToken", value: this.props.nextPageToken }],
					resultRender: function resultRender(olderPostsData) {

						setTimeout(function () {

							console.log(olderPostsData.items);

							var joinedItems = that.props.data.concat(olderPostsData.items);

							//filter by unique
							joinedItems = Array.from(new Set(joinedItems));

							that.props.onUpdateArchive(joinedItems);
							that.props.onNextPageTokenUpdate(olderPostsData.nextPageToken || null);

							that.setState({ gettingOlder: false });
						}, 10);

						return _react2.default.createElement('div', null);
					} }),
				!this.state.gettingOlder && this.props.nextPageToken && _react2.default.createElement(
					'a',
					{ onClick: this.getOlderPosts, style: {
							cursor: 'pointer'
						} },
					' Older Posts'
				)
			);
		}
	}]);

	return DreamBlogArchive;
}(_react.Component);

function mapStateToProps(state) {
	return {
		data: state.blogArchive,
		nextPageToken: state.blogNextPageToken
	};
}

function matchDispatchToProps(dispatch) {
	return (0, _redux.bindActionCreators)({
		onSelectPost: function onSelectPost(post) {
			return {
				type: "BLOG_POST_SELECTED",
				payload: post
			};
		}, onUpdateArchive: function onUpdateArchive(archiveData) {
			return {
				type: "BLOG_ARCHIVE_UPDATED",
				payload: archiveData
			};
		}, onNextPageTokenUpdate: function onNextPageTokenUpdate(nextPageToken) {
			return {
				type: "NEXT_PAGE_TOKEN_UPDATED",
				payload: nextPageToken
			};
		} }, dispatch);
}

exports.default = (0, _reactRedux.connect)(mapStateToProps, matchDispatchToProps)(DreamBlogArchive);