'use strict';

Object.defineProperty(exports, "__esModule", {
	value: true
});

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _styles = require('@material-ui/core/styles');

var _Utils = require('../Utils');

var _Utils2 = _interopRequireDefault(_Utils);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _reactBootstrap = require('react-bootstrap');

var _CryptoDonationModal = require('../components/CryptoDonationModal');

var _CryptoDonationModal2 = _interopRequireDefault(_CryptoDonationModal);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var CryptoButton = function (_React$PureComponent) {
	_inherits(CryptoButton, _React$PureComponent);

	function CryptoButton(props) {
		_classCallCheck(this, CryptoButton);

		var _this = _possibleConstructorReturn(this, (CryptoButton.__proto__ || Object.getPrototypeOf(CryptoButton)).call(this, props));

		_this.onHoverEnter = function () {
			_this.setState({
				focused: true
			});
		};

		_this.onHoverLeave = function () {
			_this.setState({
				focused: false
			});
		};

		_this.state = {
			focused: false,
			showModal: false
		};
		return _this;
	}

	_createClass(CryptoButton, [{
		key: 'getStyles',
		value: function getStyles() {

			var palette = this.props.theme.palette;
			var styles = {
				container: {
					listStyle: 'none',
					display: 'inline-block'
				},
				link: {
					display: 'inline-block',
					background: 'none',
					width: '2.5em',
					height: '2.5em',
					lineHeight: '2.5em',
					textAlign: 'center',
					borderRadius: '100%',
					cursor: 'pointer',
					border: 0,
					color: palette.textColor
				},
				icon: {
					width: 30
				}
			};
			return styles;
		}
	}, {
		key: 'render',
		value: function render() {
			var _this2 = this;

			var styles = this.getStyles();

			var componentClasses = ['kokoLib_cryptoIcon'];
			if (this.state.focused) {
				componentClasses.push('focused');
			}

			return _react2.default.createElement(
				'li',
				{ style: styles.container },
				_react2.default.createElement('div', { dangerouslySetInnerHTML: {
						__html: '\n\t\t\t\t\t\t<style>\n\t\t\t\t\t\t\t.kokoLib_cryptoIcon {\n\t\t\t\t\t\t\t\t-webkit-transition: 0.6s;\n\t\t\t\t\t\t\t\t-moz-transition: 0.6s;\n\t\t\t\t\t\t\t\t-o-transition: 0.6s;\n\t\t\t\t\t\t\t\ttransition: 0.6s;\n\t\t\t\t\t\t\t}\n\n\t\t\t\t\t\t\t.kokoLib_cryptoIcon.focused {\n\t\t\t\t\t\t\t\ttransform:scale(1.1) !important;\n\t\t\t\t\t\t\t}\n\n\t\t\t\t\t\t</style>\n\t\t\t\t\t\t'
					} }),
				_react2.default.createElement(
					'a',
					{ onClick: function onClick() {
							return _this2.setState({ showModal: true });
						},
						style: styles.link },
					_react2.default.createElement(
						'div',
						{ className: componentClasses.join(' ') },
						_react2.default.createElement(_reactBootstrap.Image, { src: this.props.icon,
							onMouseEnter: this.onHoverEnter,
							onMouseLeave: this.onHoverLeave,
							style: styles.icon })
					)
				),
				_react2.default.createElement(_CryptoDonationModal2.default, _extends({}, this.props, { show: this.state.showModal,
					onHide: function onHide() {
						return _this2.setState({ showModal: false });
					} }))
			);
		}
	}]);

	return CryptoButton;
}(_react2.default.PureComponent);

CryptoButton.propTypes = {
	name: _propTypes2.default.string,
	icon: _propTypes2.default.string,
	address: _propTypes2.default.string,
	qrCode: _propTypes2.default.string
};
CryptoButton.defaultProps = {
	name: 'crypto',
	icon: 'envelope',
	address: 'asdasdasdasdasdas',
	qrCode: 'Email'
};
exports.default = (0, _styles.withTheme)()(CryptoButton);