'use strict';

Object.defineProperty(exports, "__esModule", {
	value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _styles = require('@material-ui/core/styles');

var _Utils = require('../Utils');

var _Utils2 = _interopRequireDefault(_Utils);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var SocialMediaButton = function (_React$PureComponent) {
	_inherits(SocialMediaButton, _React$PureComponent);

	function SocialMediaButton() {
		_classCallCheck(this, SocialMediaButton);

		return _possibleConstructorReturn(this, (SocialMediaButton.__proto__ || Object.getPrototypeOf(SocialMediaButton)).apply(this, arguments));
	}

	_createClass(SocialMediaButton, [{
		key: 'getStyles',
		value: function getStyles() {

			var palette = this.props.theme.palette;

			var styles = {
				container: {
					listStyle: 'none',
					display: 'inline-block'
				},
				link: {
					display: 'inline-block',
					background: 'none',
					width: '2.5em',
					height: '2.5em',
					lineHeight: '2.5em',
					textAlign: 'center',
					borderRadius: '100%',
					border: 0,
					color: palette.textColor
				}
			};
			return styles;
		}
	}, {
		key: 'render',
		value: function render() {

			var styles = this.getStyles();

			return _react2.default.createElement(
				'li',
				{ style: styles.container },
				_react2.default.createElement('div', { dangerouslySetInnerHTML: {
						__html: '\n\t\t\t\t\t\t<style>\n\t\t\t\t\t\t\t.kokoLib_socialMediaIcon:before {\n\t\t\t\t\t\t\t\tdisplay: inline-block;\n\t\t\t\t\t\t\t\tfont-family: FontAwesome;\n\t\t\t\t\t\t\t\tfont-size: 1.25em;\n\t\t\t\t\t\t\t\ttext-decoration: none;\n\t\t\t\t\t\t\t\tfont-style: normal;\n\t\t\t\t\t\t\t\tfont-weight: normal;\n\t\t\t\t\t\t\t\tline-height: 1;\n\t\t\t\t\t\t\t\t-webkit-font-smoothing: antialiased;\n\t\t\t\t\t\t\t\t-moz-osx-font-smoothing: grayscale;\n\t\t\t\t\t\t\t}\n\n\t\t\t\t\t\t\t.kokoLib_socialMediaIcon:hover {\n\t\t\t\t\t\t\t\tcolor: ' + this.props.theme.palette.accent1Color + ' !important;\n\t\t\t\t\t\t\t}\n\t\t\t\t\t\t</style>\n\t\t\t\t\t\t'
					} }),
				_react2.default.createElement(
					'a',
					{ className: "kokoLib_socialMediaIcon fa-" + this.props.icon,
						href: this.props.link,
						target: '_blank',
						style: styles.link },
					_react2.default.createElement(
						'span',
						{ className: 'label', style: { display: "none" } },
						_Utils2.default.toTitleCase(this.props.name)
					)
				)
			);
		}
	}]);

	return SocialMediaButton;
}(_react2.default.PureComponent);

SocialMediaButton.propTypes = {
	icon: _propTypes2.default.string,
	link: _propTypes2.default.string,
	name: _propTypes2.default.string
};
SocialMediaButton.defaultProps = {
	icon: 'envelope',
	link: 'mailto:you@email.com',
	name: 'Email'
};
exports.default = (0, _styles.withTheme)()(SocialMediaButton);